;copywrite 2000 Samuel Stearley


TraitGrapher2:
	move.l	(a7)+,d3
TraitGrapher:
	bsr		MenuSelect
	move.l	d3,-(a7)
;------------------------------------------
;NOW TO GENERATE A LIST OF INTERGERS TO
;LATER CONVERT TO COORDINATES ON THE SCREEN.
;------------------------------------------
	lea		labelTypeChangeIndicator(pc),a0
	move.b	#1,(a0)
	moveq		#0,d0				;atomic number=0
	lsl.w		#1,d1
	lea		dataFormatTypes(pc),a0	;details how the data is stored
	lea		100(a3),a1			;INTERGER LIST
	move.b	-1(a0,d1),d3		;get data descriptive byte
	move.b	-2(a0,d1),d5		;get nyble size byte
	lsr.w		#1,d1
	move.w	d5,a5
GetDataLoop:
	moveq		#0,d4				;will hold the interger that I will get.
	addq.w	#1,d0				;atomic number counter
	bsr		Advancer			;will return a6 as a pointer, d6 has flags
							;  and d2 points to existence bit in flags
	btst.l	d2,d6				;is the data item known?
	bne.s		GotInterger			;then leave it at zero
	tst.b		d3
	bpl.s		OnlyBcd			;bit seven says that it might be a word
	subq.b	#1,d2				;point to bit that says it might be a word
	btst.l	d2,d6				;Is it a word?
	beq.s		OnlyBcd
	move.b	(a6)+,d4
	lsl.w		#8,d4
	move.b	(a6),d4
	move.b	d3,d6				;copy in the extra precision
	and.b		#$0F,d6			;get rid of word indicator bit
	beq.s		GotInterger			;zero so no extra precision
	sub.l		a4,a4				;make a4 zero so that d4 is left positive
	bra.s		ExtraZeros			;since d6 was non zero there is extra precision
OnlyBcd:
	move.w	a5,d5				;get size of data item
	move.b	(a6),d6			;get radix and first nyble- done with flags
	move.w	d6,a4
	lsr.b		#4,d6				;isolate radix
	and.b		#$07,d6			;keep lower 3 bits
	subq.b	#1,d6
	move.b	d3,d2				;get the extra precision nybles
	and.b		#$07,d2			;find out how many nybles total to get
	add.b		d2,d6				;  so sum them
	moveq		#0,d2
NybleLoop:

;---Get lower nyble----

	move.b	(a6)+,d2
	and.b		#$0F,d2
	cmp.b		#$A,d2
	bcc.s		ExtraZeros
	mulu		#10,d4
	add.w		d2,d4
	subq.b	#1,d6
	beq.s		DoneWithBcd
	subq.b	#1,d5				;decrease size of byte- if it hits zero before d6
							;  then it is not done gettin extra precision but
							;  there is nothing to get that from
	beq.s		ExtraZeros

;---Get upper nyble----

	move.b	(a6),d2
	lsr.b		#4,d2
	cmp.b		#$A,d2
	bcc.s		ExtraZeros
	mulu		#10,d4	
	add.w		d2,d4
	subq.b	#1,d6
	beq.s		DoneWithBcd
	subq.b	#1,d5
	bne.s		NybleLoop

;---Deal with extra precision that could not be dealt
;---with by getting extra nybles.

ExtraZeros:
	mulu		#10,d4
	subq.b	#1,d6
	bne.s		ExtraZeros

;---Make it negative or positive----

DoneWithBcd:
	move.w	a4,d6			;a4 held the sign bit of the bcd
	tst.b		d6
	bpl.s		D4IsPositive
	neg.w		d4
D4IsPositive:
GotInterger:
	move.w	d4,(a1)+		;store it to the list
	cmp.w		#112,d0
	bne		GetDataLoop
;------------------------------------
;TIME TO DRAW THE CHART
;------------------------------------
	moveq		#1,d3				;initial atomic number
	moveq		#0,d4
	move.b	d1,d4				;there will be text display so save it in a good
							;  register -copy of the data items #
RegenGraph_E2
	lea		yBoundTable(pc),a5
RegenGraph:
	bsr		ClearScr
	move.w	d4,d1
	add.w		d1,d1
	lea		dataFormatTypes(pc),a1
	move.b	-1(a1,d1),d0		;get extra precision byte
	and.w		#$0F,d0			;get rid of possible interger flag
	add.w		d1,d1
	move.w	-4(a5,d1),d5		;get y min
	move.w	-2(a5,d1),d7		;get y max

;-----CONVERT YMAX TO A STRING----

	lea		60(a3),a0
	moveq		#0,d1
	move.w	d7,d1
	clr.b		(a0)				;zero terminate
	move.w	#4,-(a7)
	subq.l	#4,a7
 ifd ti89
	move.l	#160*65536+95,-(a7)	;cordinates- x will be decreased
 endc

 ifnd ti89
	move.l	#160*65536+123,-(a7)
 endc

StrGenLoop:
	divu		#10,d1
	swap		d1				;get remainder
	add.b		#'0',d1
	subq.w	#4,(a7)			;decrease x
	move.b	d1,-(a0)
	subq.b	#1,d0				;is a decimal place needed?
	bne.s		NoDecimal
	move.b	#'.',-(a0)
	subq.w	#2,(a7)			;decrease x
NoDecimal:
	clr.w		d1
	swap		d1				;see if the entire thing is zero
	bne.s		StrGenLoop			;keep going till the entire is zero

;-----DISPLAY Y MAX STRING AND ITS PROMPT------

	move.l	a0,4(a7)
	jsr		(a2)
	lea		ymax(pc),a0			;pointer to string
	move.l	a0,4(a7)			;string to draw
	sub.w		#21,(a7)			;alter x
	jsr		(a2)				;display prompt
	lea		10(a7),a7

;----DRAW THE GRAPH AXES----

	sub.w		d5,d7				;get the difference
	move.l	#LCD_MEM,a1			;pointer to draw to
	lea		6*30(a1),a0			;copy for x-axis
	moveq		#1,d0
	ror.b		#1,d0				;set high bit

 ifd ti89
	moveq		#GRAPH_AREA-1,d2
 endc

 ifnd ti89
	moveq		#GRAPH_AREA-10,d2
 endc

	moveq		#30,d6
	bset.b	#6,(a0)
LineLoop:
	or.b		d0,(a0)
	add.l		d6,a0
	dbra		d2,LineLoop
	move.w	d5,d0
	neg.w		d0				;subtract from zero

 ifd ti89
	muls		#GRAPH_AREA,d0
 endc

 ifnd ti89
	muls		#GRAPH_AREA-9,d0
 endc

	divs		d7,d0				;divide by ymin-ymax

 ifd ti89
	moveq		#PIXEL_HEIGHT,d2
 endc

 ifnd ti89
	moveq		#PIXEL_HEIGHT-9,d2	;cordinate is from the bottom
 endc

	sub.w		d0,d2				;d2 now has the y from the top
	mulu		#30,d2			;video memory is 30 bytes wide
	add.l		d2,a1				;point to line of x-axis
	moveq		#-1,d6
	moveq		#2,d0
	lea		-30(a1),a0
	or.l		#%00100000000010000000001000000000,(a0)+	;tick marks
	move.l	#%10000000001000000000100000000010,(a0)+
	move.l	#%00000000100000000010000000001000,(a0)+
line_loop2
	or.l		d6,(a1)+			;put in x-axis
	dbra		d0,line_loop2
	move.w	#%0000001000000000,(a0)+
	or.w		d6,(a1)+
	move.b	#%10000000,(a0)
	or.b		d6,(a1)
;-----------------------------------------------------------------------
;THIS LOOP ACCESSES THE INTERGER LIST, FINDS THE ON SCREEN Y VALUE,
;STORES THAT TO A LIST, AND THEN PLACES THE PIXEL ON SCREEN.
;
;THE Y CORDINATE LIST IS USED FOR TRACING, THE INTERGER LIST IS USED
;WHEN YMAX VARIABLE IS ADJUSTED WHICH CAUSES THE LIST OF ON SCREEN
;Y VALUES TO BE RENDERED USELESS.
;-----------------------------------------------------------------------
	move.l	#LCD_MEM,a0
	lea		100(a3),a1		;pointer to y word list
	lea		400(a3),a4		;pointet to y cordinate list
	moveq		#16,d0		;set bit 4
	moveq		#111,d1
PixelLoop:
	move.w	(a1)+,d2		;get the y
	sub.w		d5,d2			;number-ymin

 ifd ti89
	muls		#GRAPH_AREA,d2	;multiply by graph area height
 endc

 ifnd ti89
	muls		#GRAPH_AREA-9,d2
 endc

	divs		d7,d2			;divide by ymax-ymin

 ifd ti89
	moveq		#PIXEL_HEIGHT,d6	;all done with the flags so move in screen height
 endc

 ifnd ti89
	moveq		#PIXEL_HEIGHT-9,d6
 endc

	sub.w		d2,d6			;turn it into a real cordinate
	bcc.s		OnScreen
	moveq		#6,d6			;force it onto the screen
OnScreen:
	move.w	d6,(a4)+		;store it in the cordinate buffer
	mulu		#30,d6
	lea		0(a0,d6),a6
	eor.b		d0,(a6)		;set the pixel
	ror.b		#1,d0
	bcc.s		SameByte
	addq.l	#1,a0
SameByte:
	dbra		d1,PixelLoop

;----Do the unit title-----

	lea		unitsTable(pc),a0
	lea		-1(a0,d4),a6		;get the unit to print
	lea		units(pc),a0		;get the string structure
	bsr		DisplayIndexedStrings	;print the right string

;-----Back it up-----------

	lea		700(a3),a0
	move.l	#LCD_MEM,a1
	move.w	#959,d0
CopyLoops:
	move.l	(a1)+,(a0)+
	dbra		d0,CopyLoops
;----------------------------------------------------------
;NOW THE TRACING LOOP
;----------------------------------------------------------
KeyLoop3:

;---restore screen---

	lea		700(a3),a0
	move.l	#LCD_MEM,a1
	move.w	#959,d0
CopyLoops2:
	move.l	(a0)+,(a1)+
	dbra		d0,CopyLoops2

;---Place Marker---

	lea		398(a3),a0		;the index will point 2 bytes too far if 400(a3) is used.
	move.w	#4,-(a7)
	pea		marker(pc)
	subq.l	#4,a7
	move.w	d3,(a7)		;x

 ifnd ti89
	subq.w	#1,(a7)
 endc

	move.w	d3,d0
	lsl.w		#1,d0			;double it into an index
	move.w	0(a0,d0),d1		;get y
	subq.w	#5,d1			;alter it
	move.w	d1,2(a7)		;put on the stack
	jsr		(a2)
	addq.l	#4,a7

;---Display element name-------

 ifd ti89
	lea		names(pc),a0
	move.w	d3,d0
	bsr		DisplayIndexedStrings_E2
 endc

;---Display atomic number, symbol---

	bsr		DSymbolNumber

;---Display the data----

 
	move.l	#120*65536+0,-(a7)

 ifnd ti92
	moveq		#0,d6
	bsr		MakeString_E2
	tst.w		d0
	beq		UnknownItem
	move.l	a6,4(a7)
	bra		DoneValue
 endc

 ifd ti92
	lea		dataFormatTypes(pc),a0
	move.w	d3,d0
	move.w	d4,d1
	bsr		Advancer
	btst.l	d2,d6			;is data known?
	bne.s		UnknownItem
	lsl.w		#1,d1			;make it an index
	move.b	-2(a0,d1),d0	;get size
	tst.b		-1(a0,d1)		;get flag
	bpl.s		NotAWord
	subq.b	#1,d2
	btst.l	d2,d6
	beq.s		NotAWord
	bsr		BinToDecimal	;convert it- will set string address on the stack
	bra		DoneValue
NotAWord:
	moveq		#0,d2			;will use byte as a word
	move.b	d0,d2			;use the byte
	lsr.w		#1,d2			;divide it in half
	subq.w	#1,d2			;it is one too big
	bsr		ConvertBcd		;convert it- will set string address on the stack
	bra.s		DoneValue
 endc


UnknownItem:
	lea		unknown(pc),a0
	move.l	a0,4(a7)
DoneValue:
	jsr		(a2)
	lea		10(a7),a7

KeyLoop3_E2:
	bsr		HandleCommonKeys		;this will handle the right, left, and f1-f3
							;  it will return the zero flag set if the key
							;  was handled, which means the atomic number
							;  d3 was changed.
 ifd ti89
	beq		KeyLoop3
	cmp.b		#K_DATUM_SCROLLER,d0
	beq		ExportIt
	cmp.b		#K_GRAPH,d0
	beq		TraitGrapher2
	lea		yMaxLimitsAndIncrements(pc),a0	;pointer to the limits and increments
	lsl.w		#2,d4			;quadrouple it into an index
	move.w	-4(a0,d4.w),d1	;get increment
	move.w	-2(a0,d4.w),d2	;get limit
	move.w	-2(a5,d4.w),d5	;get ymax
	cmp.b		#K_UP,d0
	beq.s		IncreaseYmax
	cmp.b		#K_DOWN,d0
	beq.s		DecreaseYmax
	lsr.w		#2,d4
	cmp.b		#K_ESC,d0
	bne		KeyLoop3_E2
 endc

 ifnd ti89
	beq		KeyLoop3

	ifd ti92plus
		cmp.w		#K_DATUM_SCROLLER,d0
		beq		ExportIt
	endc

	cmp.w		#K_GRAPH,d0
	beq		TraitGrapher2
	lea		yMaxLimitsAndIncrements(pc),a0	;pointer to the limits and increments
	lsl.w		#2,d4			;quadrouple it into an index
	move.w	-4(a0,d4.w),d1	;get increment
	move.w	-2(a0,d4.w),d2	;get limit
	move.w	-2(a5,d4.w),d5	;get ymax
	cmp.w		#K_UP,d0
	beq.s		IncreaseYmax
	cmp.w		#K_DOWN,d0
	beq.s		DecreaseYmax
	lsr.w		#2,d4
	cmp.w		#K_ESC,d0
	bne		KeyLoop3_E2
 endc

;----Exit---------

	move.l	(a7)+,d3	
	bra		SkipWraper2		;return

;----ymax altering routines-----

IncreaseYmax:
D2IsLarger:
	add.w		d1,d5
	bpl.s		SkipUndoMath2
	sub.w		d1,d5
SkipUndoMath2:
	move.w	d5,-2(a5,d4)	;save the new ymax
	lsr.w		#2,d4
	bra		RegenGraph
DecreaseYmax:
	sub.w		d1,d5
	cmp.w		d5,d2
	bcc.s		D2IsLarger
	bra.s		SkipUndoMath2

 ifnd ti92
ExportIt:
	moveq		#0,d6
	bsr		MakeString_E2
	tst.l		d0
	beq		KeyLoop3_E2
	pea		RegenGraph_E2		;because the backup buffer will be corrupted
	bsr		ExportIntoHistory_E2
 endc