;by Samuel Stearley copywrite 2000

;-----------------------------------------------------------------------------------------+
;					KEY TESTING FOR MOVEMENT
;-----------------------------------------------------------------------------------------+
TryAgain:

 ifd ti89
	lea		blinker(pc),a0
	move.w	d3,(a0)				;it will now blink the atomic number
 endc

	bsr		Idler2				;handles moving left, right, smart searches
	beq.s		NumberToIndex			;  and exiting, which are all actions shared
	moveq		#18,d1				;  with the other data pages.

 ifnd ti89
	cmp.w		#K_CLEAR,d0
	bne		NotClear
	lea		subOrbitalOrdering(pc),a0
	not.b		(a0)
	bra		ReDisplay
NotClear
	cmpi.w	#K_DOWN,d0
	beq.s		MoveVertically
	neg.w		d1
	cmpi.w	#K_UP,d0
	beq.s		MoveVertically
	cmpi.w	#K_APPS,d0
	beq		DisplayElectronDataPage
	cmpi.w	#K_3RD,d0
	beq		Display3rd

	 ifd ti92plus
		cmp.w		#K_F8,d0
		beq		DisplayCustom
		cmp.w		#K_DATUM_SCROLLER,d0
		bne		NoDataStorage
		moveq		#2,d4
		lea		dataPrompts(pc),a4
		move.b	labelType(pc),d0
		beq.s		NotDescriptive4
		lea		dataPrompts2(pc),a4
NotDescriptive4:
		lea		exportMainDataPageShortcuts(pc),a5
		bsr		DataScroller
		bra		NumberToIndex	
NoDataStorage:

	 endc

	bra.s		TryAgain
 endc

 ifd ti89
	cmp.b		#K_CLEAR,d0
	bne		NotClear
	lea		subOrbitalOrdering(pc),a0
	not.b		(a0)
	bra		ReDisplay
NotClear:
	cmp.b		#K_DATUM_SCROLLER,d0
	bne		NoDataStorage
	moveq		#2,d4
	lea		dataPrompts(pc),a4
	move.b	labelType(pc),d0
	beq.s		NotDescriptive4
	lea		dataPrompts2(pc),a4
NotDescriptive4:
	lea		exportMainDataPageShortcuts(pc),a5
	bsr		DataScroller
	bra		NumberToIndex	
NoDataStorage:
	cmpi.b	#K_DOWN,d0
	beq.s		MoveVertically
	neg.w		d1
	cmpi.b	#K_UP,d0
	beq.s		MoveVertically
	cmpi.b	#K_APPS,d0
	beq		DisplayElectronDataPage
	cmpi.b	#K_BACK,d0
	beq		Display3rd
	cmpi.b	#K_CATALOG,d0
	beq		DisplayCustom
	bra.s		TryAgain
 endc
;---------------------------------------------------
;ALTER THE INDEX INTO THE TABLE TO MOVE VERTICALLY
;THEN GET THE NEW ATOMIC NUMBER
;---------------------------------------------------
MoveVertically:
	lea		tablePosData(pc),a1
	move.w	(a3),d2				;get the previous index into the array
MoveVerticallyLoop:
	move.w	#179,d4				;what to add or subtract to wrap
	add.w		d1,d2					;increase or decrease the index
	bmi.s		Wraper				;now check it it is too low
	neg.w		d4					;it will wrap by subtraction not addition
	cmpi.w	#179,d2				;now check if it is too high
	bcs.s		SkipWraper				;branch if it is within limits
Wraper:
	add.w		d4,d2					;this will adjust it if it went out of limits
SkipWraper:
	move.b	0(a1,d2.w),d3			;if it is non zero then done else it has
	beq.s		MoveVerticallyLoop		;  to continue moving either up or dow
;-------------------------------------------------------------------
;USES THE ATOMIC NUMBER TO FIND AN INDEX INTO THE POSITION TABLE
:-------------------------------------------------------------------
NumberToIndex:
	move.b	labelTypeChangeIndicator(pc),d2
	bne		ReInit
	lea		tablePosData(pc),a1
NumberTIndex_E2:
	moveq		#-1,d2
Loop:
	addq.L	#1,d2
	cmp.b		0(a1,d2),d3
	bne.s		Loop
	move.w	d2,(a3)
;----------------------------------------------------------------------------
;THIS WILL COPY THE PICTURE OF THE TABLE AND THE PROMPTS ONTO THE SCREEN TO
;CLEAR OFF THE LEFT OVER PIXELS AND THEN IT TURNS AN INDEX INTO THE ADDRESS
;OF THE BIT AND SETS IT.
;----------------------------------------------------------------------------
ReDisplay:
	lea		700(a3),a0
	move.L	#LCD_MEM,a1
	move.w	#959,d0
CopyLoop2:
	move.l	(a0)+,(a1)+
	dbra		d0,CopyLoop2

 ifd ti89
	bsr		InvertBox
 endc

 ifnd ti89
	move.w	(a3),d2
	moveq		#90,d0		;width of 3 video memory lines
	move.L	#LCD_MEM+7*30,a0
LoopA:
	sub.w		#18,d2		;for every multiple of 18 the index is, it has
						;  to move 2 or 3 lines down
	add.l		d0,a0
	bcc.s		LoopA
	add.w		#18,d2
	move.w	d2,2(a3)		;save it for the group part

	mulu		#3,d2
	addq.w	#1,d2
	move.w	d2,d1			;save a copy
	lsr.w		#3,d2			;divide by 8
	not.w		d1			;inverting a 3 bit value is same as a
						;  subtracting from 7
	and.w		#7,d1			;only want last 3 bits
	add.l		d2,a0			;point to byte that has the pixel
	bset.b	d1,(a0)
	bset.b	d1,30(a0)
	subq.b	#1,d1
	bcc.s		SkipMoveOver
	moveq		#7,d1
	addq.l	#1,a0
SkipMoveOver:
	bset.b	d1,(a0)
	bset.b	d1,30(a0)
 endc



;after this code execution goes into the main display code in pages.asm