;by Samuel Stearley copywrite 2000

;----------------------------------------------------
;DISPLAY THE MAIN PAGE
;----------------------------------------------------

;-----------------------------------------
;Get flags and and a pointer to the data
;-----------------------------------------
	move.w	d3,d7
	ADD.w		d7,d7
	lea		elementOffsetTable(pc),a1
	move.w	-2(a1,d7.w),d0
	lea		0(A1,d0.w),a6
	add.w		d7,d7
	lea		elementFlags(pc),a0
	move.l	-4(a0,d7.w),d6
;-----------------------------------------
;Name
;-----------------------------------------
	lea		names(pc),a0
	move.w	d3,d0
	bsr		DisplayIndexedStrings_E2
;-----------------------------------------
;Group
;-----------------------------------------
	move.w	#4,-(a7)
	subq.l	#8,a7					;make gap on the stack
	cmpi.b	#7,(a6)				;is it a lanthanide?
	beq.s		RareEarth
	cmp.b		#8,(a6)				;is it an actinide?
	beq.s		RareEarth

 ifnd ti89
	move.l	#230*65536+115,(a7)		;x and y
 endc

 ifd ti89
	move.l	#150*65536+9,(a7)
 endc

	move.w	2(a3),d0				;get group
	move.w	d0,d1
	addq.w	#1,d0
	bsr		BinToDecimal_E2			;convert d0 to a string and put adress on stack
	sub.w		d5,(a7)				;decrease x-left justify it
	move.l	#$29280000,d0			;")(",00->d0
	lsl.w		#1,d1					;double it into an index
	lea		groupInfo(pc),a0			;pointer to info
	move.w	0(a0,d1),d0
	rol.l		#8,d0
	move.l	d0,60(a3)				;append 4 byte string to the interger string
	clr.b		64(a3)				;zero terminate it
	jsr		(a2)					;display the string
RareEarth:
;-----------------------------------------
;Type
;-----------------------------------------
	lea		elementTypeArray(pc),a0
	bsr		DisplayIndexedStrings
;-----------------------------------------
;Symbol
;-----------------------------------------
	lea		symbols(pc),a0
	move.w	d3,d0
	bsr		DisplayIndexedStrings_E2
;------------------------------------------
;Atomic number
;------------------------------------------
 ifnd ti89
	move.l	#$0039000F,(a7)			;cordinates
 endc

 ifd ti89
	move.l	#38*65536+15,(a7)
 endc

	move.w	d3,d0					;copy atomic number
	bsr		BinToDecimal_E2			;it will place string address on the stack
	jsr		(a2)					;display it
;------------------------------------------
;Atomic mass
;------------------------------------------
	moveq		#2,d2					;convert 4 bytes
	addq.w	#6,2(A7)				;move the y down
	bsr		ConvertBcd				;it will place string address on the stack
	cmpi.b	#104,d3				;does it need parenthesis?
	bcs.s		ParenthesisNotNeeded
	move.b	#')',(a0)+
	clr.b		(a0)					;zero terminate
	subq.l	#1,4(a7)				;alter the address
	move.b	#'(',49(a3)
ParenthesisNotNeeded:
	jsr		(a2)					;display it
;------------------------------------------
;2 byte bcd numeric data 
;------------------------------------------
	lea		dataCordinates(pc),a4		;pointer to cordinates
	moveq		#2,d7					;first bit to test
	moveq		#1,d4					;display two things
	bsr		Disp2ByteBcd
;------------------------------------------
;Common oxsets
;------------------------------------------
 ifnd ti89
	move.l	#$00630009,(a7)			;cordinates
 endc

 ifd ti89
	move.l	#79*65536+9,(a7)
 endc

	btst.w	#3,d6					;Are there any oxsets?
	bne.s		NoOxsets
	move.l	4(a7),a0				;string pointer is already on the stack
	moveq		#-83,d4				;negative sign
	bsr		CycleThrough			;make data into a string
	moveq		#'+',d4				;positive sign
	bsr		CycleThrough			;make data into a string
	clr.b		-(a0)					;zero terminate and overwrite the end comma
	jsr		(a2)
NoOxsets:
	lea		10(a7),a7
;------------------------------------------
;Numeric data
;------------------------------------------
	moveq		#12,d4				;13 things to display	
	moveq		#5,d7					;first bit to test
	bsr		DataDisplayLoop
;-----------------------------
;state at stp
;-----------------------------
	move.l	d6,d0					;copy of the flags
	clr.w		d0					;will be using two bits as a word
	rol.l		#2,d0					;get those two bits
	lea		stateAtStp(pc),a0			;input to the call
	bsr		DisplayIndexedStrings_E2	;display the appropriate label
;------------------------------------------------------
;Generate 1 dimensional electron cloud model matrix
;------------------------------------------------------
	lea		electronDataFlags(pc),a0
	move.w	d3,d0
	add.w		d0,d0
	move.w	-2(a0,d0.w),d6
	lea		levelLimits(pc),a0		;the level limits
	lea		cloudBases-6(pc),a1		;strings of bases and the base limits
	moveq		#-1,d7
	move.w	d3,d2
Loopsss:
	lea		6(a3),a5				;point to where to make the matrix
	addq.l	#6,a1					;point to the next base limit and string
Loops:
	addq.l	#1,d7
	move.b	(a0)+,d5				;get level limit
	bsr		CheckAbnormal
	move.b	d7,(a5)+				;save the position
	move.b	d5,(a5)+				;what the position has to be
	st.b		(a5)					;set all bits at a5- this is the terminator
	sub.b		d5,d2
	bls.s		DoneNow
	cmp.b		(a1),d7				;checks if a new base is needed
	bcs.s		Loops					;d7 is still smaller than the base limit
	bra.s		Loopsss				;re initiate the matrix and get a new base
DoneNow:
	add.b		d2,-(a5)
;-------------------------------------------------------
;Display the base element of the electron cloud
;diagram.
;-------------------------------------------------------
 ifnd ti89
	move.l	#(81+D_ADD_X)*65536+115,d4	;cordinates
 endc

 ifd ti89
	move.l	#(81+D_ADD_X)*65536+95,d4
 endc

	addq.l	#1,a1
	tst.b		(a1)
	beq		NoBase
	move.w	#4,-(a7)
	move.l	a1,-(a7)				;get past the base limit byte to the string
	move.l	d4,-(a7)				;put them on the stack
	add.l		#16*65536,d4
	jsr		(a2)
	lea		10(a7),a7

;----Maybe a re-ordering is needed?------

NoBase:
	move.b	subOrbitalOrdering(pc),d0
	beq		NotNeeded
	lea		bohrAdditionTable(pc),a0
	lea		20(a3),a1
	move.l	a1,a5
	moveq		#0,d7
	moveq		#64,d5			;set bit 6
KeepReordering:
	lea		4(a3),a4
ContinueOrdering:
IgnoreIt:
	addq.l	#2,a4
	move.b	(a4),d7			;get the index
	bmi		MoveUp
	move.b	0(a0,d7),d7			;get bit to test
	btst.w	d7,d5				;is it set?
	beq		IgnoreIt
	move.w	(a4),(a1)+			;so it move it up
	st.b		(a1)
	bra		ContinueOrdering
MoveUp:
	add.w		d5,d5
	bcc		KeepReordering
	bra		Display1dLoop
;------------------------------------------------------
;now to draw the orbits with what they have to be
;filled with based on the matrix.
;------------------------------------------------------
NotNeeded:
	lea		6(a3),a5
Display1dLoop:
	moveq		#0,d7
	move.b	(a5)+,d7				;position to fill

 ifd ti89
	bmi		TryAgain
 endc

 ifnd ti89
	bmi		DisplayTextData
 endc

	move.b	(a5)+,d5
	bsr		PlaceIt				;place orbit d7 filled with d5 orbitals
	addq.l	#6,d5
	swap		d5
	add.l		d5,d4					;increase the x
	bra.s		Display1dLoop
;------------------------------------------------------
;Now display the text data that is also on the third
;data page
;------------------------------------------------------
 ifnd ti89
DisplayTextData:
	move.w	d3,d0
	moveq		#27,d1
	bsr		Advancer
	lea		crystalStructureArray(pc),a0	;input to display_indexed strings
	clr.w		d0					;will be using 4 bits as a word
	move.b	(a6),d0				;get byte with those 4 bits
	lsr.b		#4,d0					;move them down
	bsr		DisplayIndexedStringsRightJustify_E2
	move.b	(a6)+,d0				;get four bits
	and.w		#$000F,d0				;will use them as a word
	lea		acidBasePropertiesArray(pc),a0
	bsr		DisplayIndexedStringsRightJustify_E2
	lea		colorArray(pc),a0
	bsr		DisplayIndexedStringsRightJustify
	bra		TryAgain
 endc
;---Input--------------------------------------------------
;a0-> pointer to free memory
;a6->	pointer to the byte
;d4->	sign character of the charge
;---Output-------------------------------------------------
;a6->	advanced
;----------------------------------------------------------
CycleThrough:
	move.b	(a6)+,d0
	moveq		#7,d1
	moveq		#'0',d2
CycleThroughLoop:
	addq.b	#1,d2				;turn it into another character
	rol.b		#1,d0
	bcc.s		DoNotStoreTheCharge
	move.b	d2,(a0)+			;character number
	move.b	d4,(a0)+			;charge sign
	move.b	#',',(a0)+			;comma character
DoNotStoreTheCharge:
	dbra.s	d1,CycleThroughLoop
	rts
;------------------------------------------
;Checks if an orbital needs patching
;------------------------------------------
CheckAbnormal:
	btst.w	#15,d6
	beq.s		NormalDistribution
	cmp.b		(a6),d7
	bne.s		NormalDistribution
	addq.l	#1,a6
	move.b	(a6)+,d5
NormalDistribution:
	rts
;--------------------------------------------------------------------------
;			THIS WILL DISPLAY THE ELECTRON DATA PAGE
;--------------------------------------------------------------------------
ChangeCordinates:
	lea		orbitType(pc),a0
	move.b	(a0),d0
	bpl.s		NoWrapNeeded
	moveq		#2,d0
NoWrapNeeded:
	subq.b	#1,d0
	move.b	d0,(a0)
;------------------------------
;DISPLAY IT
;------------------------------
DisplayElectronDataPage:
	move.w	d3,d0					;atomic number
	moveq		#17,d1				;data item to point to
	bsr		Advancer				;get flags and a pointer to it
;-----------------------------------------
;Draw labels
;-----------------------------------------
	lea		electronDataPromptsNotForExport(pc),a4
	move.b	labelType(pc),d0
	beq		NotDescriptive7
	lea		electronDataPromptsNotForExport2(pc),a4
NotDescriptive7:
	bsr		TextDisplayLoop
	lea		electronDataPrompts(pc),a4
	move.b	labelType(pc),d0
	beq.s		NotDescriptive2
	lea		electronDataPrompts2(pc),a4
NotDescriptive2:
	bsr		TextDisplayLoop_E3
;-------------------------------------------------------------------------------
;Display the Electron cloud and generate a list of Bohr model elements in ram
;-------------------------------------------------------------------------------
	lea		bohrAdditionTable(pc),a5
	move.b	d3,d2
	moveq		#-1,d7				;position number
	clr.l		6(a3)					;initiate byte list
	clr.l		10(a3)				;initiate byte list
	moveq		#0,d4					;place routine will get it's own cordinates
LevelLoop:
	addq.l	#1,d7
	move.b	(a5)+,d0
	lea		0(a3,d0),a4
	move.b	17(a5),d5
	bsr		CheckAbnormal
	add.b		d5,(a4)
	movem.l	d2/d5/d7,-(a7)
	bsr		PlaceIt				;place orbit d7 filled with d5 electrons
	movem.l	(a7)+,d2/d5/d7
	sub.b		d5,d2
	bhi.s		LevelLoop
	add.b		d2,(a4)				;add the negative result to take off the extra
	add.b		d2,d5					;add the negative result to take off the extra
	bsr		PlaceIt
;-------------------------------------------------------------------
;Draw the bohr model list with dashes in between each list item
;-------------------------------------------------------------------
	clr.w		d0
	lea		6(a3),a4				;address of byte list
	move.w	#4,-(a7)
	subq.l	#4,a7

 ifd ti89
	move.l	#(65+ADD_X)*65536+(95+ADD_Y),d1
	move.b	orbitType(pc),d0			;check which cordinate system is used
	beq.s		CordinatesFine
	ext.l		d1					;make x=0
CordinatesFine:
	move.l	d1,-(a7)
 endc

 ifnd	ti89
	move.l	#0*65536+115,-(a7)
 endc

DispLoop:
	move.b	(a4)+,d0
	beq.s		AllDoneDispLoop
	bsr		BinToDecimal_E2
	tst.b		(a4)
	beq		SkipDash
	move.w	#45*256,60(a3)
SkipDash:
	jsr		(a2)
	add.w		d5,(a7)
	bra		DispLoop
AllDoneDispLoop:
;---------------------------------
;Normal or non normal filling
;---------------------------------
	move.w	d6,d0					;copy the flags
	and.w		#$8000,d0				;preserve bit 15
	rol.w		#1,d0					;turn the bit into a number
	lea		electronFilling(pc),a0
	bsr		DisplayIndexedStrings_E2
;---------------------------------
;Draw 2 horizontal lines
;---------------------------------
	moveq		#-1,d1
	move.L	#LCD_MEM+5*30,a0
	move.l	d1,(a0)+

 ifd Francais
	move.b	labelType(pc),d0
	beq		NoExtraPix		
	move.b	#%11111110,(a0)
NoExtraPix
 endc

	addq.l	#2,a0
	move.l	d1,(a0)+
	move.w	d1,(a0)+

 ifd Francais
	tst.b		d0
	beq		NoExtraPix2
	move.b	d1,(a0)+
	move.b	#%11100000,(a0)
NoExtraPix2:
 endc
;----------------------------------
;Numeric data
;----------------------------------
	lea		electronDataCordinates(pc),a4	;cordinates
	moveq		#2,d4			;display 3 things
	moveq		#1,d7			;first flag to test
	bsr		DataDisplayLoop	;display numeric data
;----------------------------------
;2 byte bcd numeric data
;----------------------------------
	moveq		#5,d4			;display 6 things
	moveq		#12,d7		;first bit to test
	bsr		Disp2ByteBcd	;draw it; a6 and a4 already are already loaded
;----------------------------------
;Electro Negativity
;----------------------------------
	move.w	d3,d0
	moveq		#3,d1			;want the third datum
	bsr		Advancer		;get pointer to the electronegaivity and load the flags
	moveq		#0,d4
	move.w	d2,d7			;the existence bit to test
	bsr		Disp2ByteBcd
;-----------------------------------
;All done
;-----------------------------------
	lea		10(a7),a7
	bsr		Scroller
	beq		DisplayElectronDataPage

 ifnd ti89
	cmpi.w	#K_3RD,d0
	beq		Display3rd
	cmpi.w	#K_CLEAR,d0
	beq		ChangeCordinates

	 ifd ti92plus
		cmp.w		#K_F8,d0
		beq		DisplayCustom
		cmp.b		#K_DATUM_SCROLLER,d0
		bne		NoDataStorage2
		moveq		#18,d4
		lea		electronDataPrompts(pc),a4
		move.b	labelType(pc),d0
		beq.s		NotDescriptive8
		lea		electronDataPrompts2(pc),a4
NotDescriptive8:
		lea		exportElectronDataPageShortcuts(pc),a5
		bsr		DataScroller
		bra		DisplayElectronDataPage
NoDataStorage2:

	 endc

 endc

 ifd ti89
	cmp.b		#K_DATUM_SCROLLER,d0
	bne		NoDataStorage2
	moveq		#18,d4
	lea		electronDataPrompts(pc),a4
	move.b	labelType(pc),d0
	beq.s		NotDescriptive8
	lea		electronDataPrompts2(pc),a4
NotDescriptive8:
	lea		exportElectronDataPageShortcuts(pc),a5
	bsr		DataScroller
	bra		DisplayElectronDataPage
NoDataStorage2:
	cmpi.b	#K_BACK,d0
	beq		Display3rd
	cmpi.b	#K_CLEAR,d0
	beq		ChangeCordinates
	cmp.b		#K_CATALOG,d0
	beq		DisplayCustom
 endc

	bra		NumberToIndex
;--Input---------------------------------------------------------------------
;d4->	If zero then it gets the cordinates itself, else d4 has the cordinates
;	If it is zero then it displays them with dashes else it displays the
;	number of electrons exponant style
;d5->	what it has to fill the orbital with
;d7->	the orbital to fill
;--Output--------------------------------------------------------------------
;The orbit is displayed
;----------------------------------------------------------------------------
PlaceIt:
	lsl.w		#1,d7
	move.w	#4,-(a7)
	lea		50(a3),a1
	move.l	a1,-(a7)
	lea		orbitStrings(pc),a0
	lea		0(a0,d7),a0
	move.w	(a0),(a1)+
	moveq		#0,d0
	move.l	d4,-(a7)		;cordinates
	beq		TwoDFormWithDashes
	clr.b		(a1)			;zero terminate
	jsr		(a2)
	addq.w	#8,(a7)		;alter x
	subq.w	#2,2(a7)		;alter y
	move.b	d5,d0
	bsr		BinToDecimal_E2
	bra.s		Finale
TwoDFormWithDashes:
	move.b	orbitType(pc),d0
	lea		orbitCordinates1(pc),a0
	beq.s		AllFine
	lea		orbitCordinates3(pc),a0		
	bmi.s		AllFine
	lea		orbitCordinates2(pc),a0	
AllFine:
	lea		0(a0,d7),a0
	move.b	(a0)+,d0		;y
	move.w	d0,2(a7)
	move.b	(a0),d0		;x
	move.w	d0,(a7)
	move.l	#754986240,(a1)	;"- -",0 ->(a1)
	addq.l	#1,a1			;point to first place to put a number character
	cmp.b		#10,d5
	bcs.s		ItIsLessThan10
	move.b	#'1',(a1)+
	sub.b		#10,d5
ItIsLessThan10:
	add.b		#'0',d5
	move.b	d5,(a1)
Finale:
	jsr		(a2)
	lea		10(a7),a7
	rts
;-------------------------------------------------------
;			NOW THE THIRD DATA PAGE
;-------------------------------------------------------
Display3rd:
;----------------------------------------
;GET A POINTER TO THE DATA And the flags
;----------------------------------------
	move.w	d3,d0
	moveq		#27,d1
	bsr		Advancer
;--------------------------------
;DRAW THE LABELS
;--------------------------------
	lea		_3rdDataPromptsNumeric(pc),a4
	bsr		TextDisplayLoop
;----------------------------------
;Text data
;----------------------------------
	lea		crystalStructureArray(pc),a0	;input to display_indexed strings
	clr.w		d0					;will be using 4 bits as a word
	move.b	(a6),d0				;get byte with those 4 bits
	lsr.b		#4,d0					;move them down
	bsr		DisplayIndexedStringsRightJustify_E2
	move.b	(a6)+,d0				;get four bits
	and.w		#$000F,d0				;will use them as a word
	lea		acidBasePropertiesArray(pc),a0
	bsr		DisplayIndexedStringsRightJustify_E2
	lea		colorArray(pc),a0
	bsr		DisplayIndexedStringsRightJustify
;----------------------------------
;NUMERIC DATA
;----------------------------------
	moveq		#7,d7				;flag to test
	lea		_3rdCords(pc),a4		;cordinates
	moveq		#0,d4				;display 1 thing
	bsr		Disp2ByteBcd		;display them
	moveq		#1,d5				;convert 3 bytes
	moveq		#0,d4				;display 1 thing
	bsr		Disp2ByteBcd_E2		;this entrance lets me input the size in d5
;-----------------------------------
;NOW FOR NMR ISOTOPE DATA
;-----------------------------------
	btst.b	#0,d6
	bne.s		NoDisplayNMR

;---Do the header--------

	lea		nmrStrings(pc),a4
	bsr		TextDisplayLoop_E3
	lea		(58+ADD_Y)*30+LCD_MEM,a0
	moveq		#-1,d0
	moveq		#4,d1
LineLoopt:
	move.l	d0,(a0)+
	dbra		d1,LineLoopt

;----Now to process data------	

	move.l	d3,-(a7)	;save atomic number
	move.l	d6,-(a7)
	moveq		#0,d3
	move.b	(a6)+,d3	;counter, number of rows
	move.w	#4,-(a7)
	subq.l	#4,a7
	moveq		#60+ADD_Y,d0
	move.l	d0,-(a7)	;x=0 y =60
	lea		nmrDataCords(pc),a4

;---process each row-----

;--Isotope #--

IsotopesRow:
	clr.w		(a7)			;make sure x=0
	moveq		#0,d0
	move.b	(a6)+,d0
	bsr		BinToDecimal_E2	;convert it, puts adress on the stack
	jsr		(a2)			;display isotope #
	add.w		#23,(a7)		;increase x

;--Spin--

	lea		spins(pc),a0
	moveq		#0,d0
	move.b	(a6)+,d0
GetPtrLoop:
	tst.b		(a0)+
	bne.s		GetPtrLoop
	dbra		d0,GetPtrLoop
	move.l	a0,4(a7)
	jsr		(a2)
	addq.w	#6,2(a7)

;--Abundance and Nmr frequencies--

	moveq		#3,d4			;display 4 things
	moveq		#1,d5			;size of bcds -2
	moveq		#0,d6			;fake flags
	moveq		#3,d7			;where to start  bit testing
	bsr		Disp2ByteBcd_E2
	dbra		d3,IsotopesRow
	lea		10(a7),a7
	move.l	(a7)+,d6
	move.l	(a7)+,d3
NoDisplayNMR:
;-----------------------------------
;THE LATIN NAME
;-----------------------------------
	btst.b	#1,d6
	bne.s		NoLatinName
	move.w	#4,-(a7)
	move.l	a6,-(a7)

 ifd ti89
	move.l	#95,-(a7)
 endc

 ifd ti92plus
	move.l	#115,-(a7)
 endc

	jsr		(a2)
	lea		10(a7),a7
NoLatinName:
;----------------------------------
;PAUSE
;----------------------------------
	bsr		Scroller		;display arrows number symbol and gets keys
	beq		Display3rd		;  z flag set if the key was handled

 ifnd ti89
	cmpi.w	#K_APPS,d0
	beq		DisplayElectronDataPage

	 ifd ti92plus
		cmp.w		#K_F8,d0
		beq		DisplayCustom
		cmp.w		#K_DATUM_SCROLLER,d0
		bne		NoDataStorage3
		moveq		#28,d4
		lea		_3rdDataPromptsNumeric(pc),a4
		lea		export3rdDataPageShortcuts(pc),a5
		bsr		DataScroller
		bra		Display3rd
NoDataStorage3:

	 endc

 endc

 ifd ti89
	cmp.b		#K_DATUM_SCROLLER,d0
	bne		NoDataStorage3
	lea		_3rdDataPromptsNumeric(pc),a4
	moveq		#28,d4
	lea		export3rdDataPageShortcuts(pc),a5
	bsr		DataScroller
	bra		Display3rd
NoDataStorage3:
	cmpi.b	#K_APPS,d0
	beq		DisplayElectronDataPage
	cmp.b		#K_CATALOG,d0
	beq		DisplayCustom
 endc

	bra		NumberToIndex

;-------------------------------------------------------
;	CODE FOR THE TEXT DATA PAGE
;-------------------------------------------------------

 ifnd ti92

DisplayCustom:
	bsr		ClearScr

;----First find the variable-------------

;---Get the name----

	lea		symbols_E3(pc),a0
	move.w	d3,d0
AdvancePtr:
	tst.b		(a0)+
	bne.s		AdvancePtr
	dbra		d0,AdvancePtr

;---Append to the folder---

	lea		afterFolder(pc),a1
	move.l	a1,a4
AppendLoop:
	move.b	(a0)+,(a1)+
	bne.s		AppendLoop
	add.b		#32,(a4)			;make it lower case

;---Find it----

	move.l	a7,d7
	pea		-1(a1)
	move.l	200,a6
	move.l	1600(a6),a4			;get font char width call
	move.l	384(a6),a0			;symbol find rom call
	jsr		(a0)				;find it
	move.l	d0,-(a7)
	beq		ErrorWithSymbol
	move.l	484(a6),a0			;get symbol deref
	jsr		(a0)
	move.w	$C(a0),-(a7)		;put handle on the stack
	move.l	2332(a6),a0			;get handle to esi
	jsr		(a0)				;get esi
	cmp.b		#$E0,(a0)			;see if it is a text file
	bne		ErrorWithSymbol
	move.l	600(a6),a0			;get the dereference call
	jsr		(a0)				;get pointer
	lea		5(a0),a5			;point to the data
	move.w	#4,-(a7)			;color
	lea		oneByteString(pc),a6
	move.l	a6,-(a7)
	clr.l		-(a7)				;zero the cordinates
	moveq		#0,d4				;will use byte as a word

;---Process each line---------
TextDataDisplayLoop:
	move.b	(a5)+,d4
	beq.s		DoneTextDisplayLoop
	cmp.b		#$0D,d4
	beq.s		NextLine
	move.b	d4,(a6)
	jsr		(a2)				;print the char
	move.w	d4,-(a7)
	jsr		(a4)				;get the size of it
	addq.l	#2,a7				;and pop it off
	add.w		d0,(a7)			;increase x
	cmp.w		#WRAP_LIMIT,(a7)
	bcc		NextLine2
	bra.s		TextDataDisplayLoop

;---Now for a new line---

NextLine:
	addq.l	#1,a5				;skip the $20
NextLine2
	clr.w		(a7)				;start x at zero
	addq.w	#7,2(a7)			;increase the y
	cmp.w		#98,2(a7)
	beq		DoneTextDisplayLoop
	bra.s		TextDataDisplayLoop	;continue

;---There is no text file so display a message------

ErrorWithSymbol:
	lea		noTextFile(pc),a4
	bsr		TextDisplayLoop

;---Now when it is finally done---

DoneTextDisplayLoop:
	move.l	d7,a7
	bsr		Scroller
	beq		DisplayCustom

;---See if I should go to another data page----

 ifnd ti89
	cmpi.w	#K_3RD,d0
	beq		Display3rd
	cmpi.w	#K_APPS,d0
	beq		DisplayElectronDataPage
 endc

 ifd ti89
	cmpi.b	#K_BACK,d0
	beq		Display3rd
	cmpi.b	#K_APPS,d0
	beq		DisplayElectronDataPage
 endc

	bra		NumberToIndex

 endc