;by Samuel Stearley copywrite 2000

;---inputs------------------------------------------------
;a2-> text display rom call
;d5-> copy of the current atomic number, for exiting purposes
;---output------------------------------------------------
;d3-> New atomic number
;---------------------------------------------------------

InputIt:
	bsr		NumberSmartSearcher
	bra		SkipWraper2
NumberSmartSearcher:
	movem.l	d0/d7/a5,-(a7)
InputIt2:
	lea		51(a3),a5			;string buffer
	moveq		#0,d7				;running total
Redraw1:
	subq.l	#1,a5
	divu.w	#10,d7			;reverse the math the remainder will be overwriten
	ext.l		d7
Continue:
	bsr		DisplayVertLine

 ifd ti89
	move		0,ccr				;want numbers
	bsr		GetKey
	cmpi.b	#K_ENTER,d0
	beq.s		AllDone
	cmpi.b	#K_ESC,d0
	beq.s		ExitNumberSearch
	cmpi.b	#K_CLEAR,d0
	beq.s		InputIt2
	tst.w		d7
	beq.s		CanNotBackspace
	cmpi.b	#K_BACK,d0
	beq.s		Redraw1
 endc

 ifnd ti89
	bsr		GetKey
	cmpi.w	#K_ENTER,d0
	beq.s		AllDone
	cmpi.w	#K_ESC,d0
	beq.s		ExitNumberSearch
	cmpi.w	#K_CLEAR,d0
	beq.s		InputIt2
	tst.w		d7
	beq.s		CanNotBackspace
	cmpi.w	#K_BACK,d0
	beq.s		Redraw1
 endc

CanNotBackspace:
	mulu		#10,d7
	move.b	d0,(a5)+
	sub.w		#$30,d0
	cmpi.w	#10,d0
	bcc.s		Redraw1
	add.w		d0,d7				;add on the stuff from the new character
	beq.s		Redraw1			;I do not allow the first input to be a zero
	cmp.w		#112,d7
	bhi.s		Redraw1
	cmp.w		#12,d7
	bcs.s		Continue
AllDone:
	move.w	d7,d3				;get the atomic number into d3 and test it
	beq.s		Continue
	movem.l	(a7)+,d0/d7/a5
	rts
ExitNumberSearch:
	move.w	d5,d3
	movem.l	(a7)+,d0/d7/a5
	rts
;------------------------------------------------------------------------------------
;		WILL DISPLAY EVERYTHING AND PASTE ON A VERTICAL LINE AS A CURSOR.
;------------------------------------------------------------------------------------
DisplayVertLine:
	move.l	d4,-(a7)

 ifd English
	 ifd ti89
		lea		LCD_MEM+30*38+6,a0
	 endc

	 ifnd ti89
		lea		LCD_MEM+52*30+8,a0
	 endc
 endc

 ifd Francais
	 ifd ti89
		lea		LCD_MEM+30*38+5,a0
	 endc

	 ifnd ti89
		lea		LCD_MEM+52*30+7,a0
	 endc
 endc

	moveq		#-1,d0
 ifd English
	moveq		#22,d1			;stuff to add on in the loop
 endc

 ifd Francais
	moveq		#20,d1
 endc

	moveq		#19,d2
	moveq		#1,d3
	move.l	d3,d4

 ifd English
	ror.l		#1,d4
 endc

 ifd Francais
	ror.b		#1,d4
 endc

;---Top line------

 ifd Francais
	move.b	d0,(a0)+
 endc

	move.l	d0,(a0)+
	move.l	d0,(a0)+

 ifd Francais
	move.b	d0,(a0)+
 endc

	move.b	d0,(a0)
	add.l		d1,a0

;---Side lines------

DrawLoop:
 ifd English
	move.l	d4,(a0)+
 endc

 ifd Francais
	move.b	d4,(a0)+
 endc
	clr.l		(a0)+

 ifd Francais
	clr.l		(a0)+
	clr.b		(a0)+
 endc

	move.b	d3,(a0)
	add.l		d1,a0
	dbra		d2,DrawLoop

 ;---Bottom line

 ifd Francais
	move.b	d0,(a0)+
 endc
	move.l	d0,(a0)+
	move.l	d0,(a0)+

 ifd Francais
	move.b	d0,(a0)+
 endc

	move.b	d0,(a0)
	move.w	#4,-(a7)
	move.l	a6,-(a7)

 ifd English
	 ifd ti89
		move.l	#49*65536+40,-(a7)
	 endc

	 ifnd ti89
		move.l	#65*65536+54,-(a7)
	 endc
 endc

 ifd Francais
	 ifd ti89
		move.l	#41*65536+40,-(a7)
	 endc

	 ifnd ti89
		move.l	#57*65536+54,-(a7)
	 endc
 endc

	jsr		(a2)
	lea		10(a7),a7
	move.l	(a7)+,d4

DisplayVertLine_E2:
	move.b	#'|',(a5)			;vertical line character
	clr.b		1(a5)
	move.w	#4,-(a7)
	pea		50(a3)

 ifd English
	 ifd ti89
		move.l	#49*65536+51,-(a7)
	 endc

	 ifnd ti89
		move.l	#65*65536+65,-(a7)
	 endc
 endc

 ifd Francais
	 ifd ti89
		move.l	#41*65536+51,-(a7)
	 endc

	 ifnd ti89
		move.l	#57*65536+65,-(a7)
	 endc
 endc

	bsr		SetFontMedium
	jsr		(a2)
	bsr		SetFontSmall
	lea		10(a7),a7
Return2:
	rts
;---INPUTS-------------------------------------------------------
;a2-> address of the text display rom call
;a4-> pointer to the array of strings
;d5-> copy of the atomic number, for exiting purposes
;a6-> pointer to the title
;---OUTPUTS------------------------------------------------------
;d3-> New atomic number *****OUTPUT*****
;----------------------------------------------------------------
TextSmartSearch:					;this is used for symbol and name smart searching
	bsr		SmartSearcher		;  while doing normal browsing.
	bra		SkipWraper2

SmartSearcher:
	movem.l	a0/a1/a5/d0/d4/d6,-(a7)
SmartSearcherReinit:
	lea		50(a3),a5
	move.l	a5,d6					;copy of the address to compare later
	addq.l	#1,a5
	clr.w		d7
TakeItOff:
	moveq		#32,d4				;make it into an upper case
	subq.l	#1,a5					;decrease to overwrite the old
	bsr		DisplayVertLine
	bra		RestorePosibles
GetAnotherKeyLoop:

 ifd ti89
	move		#1,ccr				;want letters
	bsr		GetKey
	cmp.l		a5,d6					;this will limit back spacing
	beq.s		NotPermitted
	clr.w		d4					;stop making it into an uppercase
	cmpi.b	#K_BACK,d0
	beq.s		TakeItOff
NotPermitted:
	cmpi.b	#K_ENTER,d0
	beq.s		EnterWasPressed
	cmpi.b	#K_ESC,d0
	beq.s		TerminateSmartSearch
	cmpi.b	#K_CLEAR,d0
	beq.s		SmartSearcherReinit
 endc

 ifnd ti89
	bsr		GetKey
	cmp.l		a5,d6
	beq.s		NotPermitted
	clr.w		d4
	cmpi.w	#K_BACK,d0
	beq.s		TakeItOff
NotPermitted:
	cmpi.w	#K_ENTER,d0
	beq.s		EnterWasPressed
	cmpi.w	#K_ESC,d0
	beq.s		TerminateSmartSearch
	cmpi.w	#K_CLEAR,d0
	beq.s		SmartSearcherReinit
 endc

	sub.b		d4,d0					;subtract off the constant
	move.b	d0,(a5)+
	bsr		DisplayVertLine_E2		;display the entered character and affix
								;  the vertical line and zero terminator
RestorePosibles
	bsr		SearchForIt
;------------------------------------------------------------
; The result of must now be analyzed
;------------------------------------------------------------
	subq.b	#1,d2
	beq.s		DoneTextSmartSearch
	bcs.s		TakeItOff
	bra.s		GetAnotherKeyLoop
;--------------------------------
;exits the smart searches
;--------------------------------
TerminateSmartSearch:
	move.w	d5,d7
EnterWasPressed:
	move.w	d7,d3
	beq.s		GetAnotherKeyLoop
;-------------------------------------
;DONE WITH A LETTER SMART SEARCH
;-------------------------------------
DoneTextSmartSearch:
	movem.l	(a7)+,a0/a1/a5/d0/d4/d6
	rts
;---------------------------------------------------------------------------------
;THIS CODE WILL COMPARE THE BYTES OF WHAT I HAVE TYPED IN TO THE BYTES THAT ARE
;STORED IN THE DATA AT THE END OF THE PROGRAM.
;---------------------------------------------------------------------------------
SearchForIt:
	move.l	a4,a1					;copy pointer of the text strings
SearchForIt_E2:
	clr.w		d7					;this will hold the possible
	clr.w		d1					;counter
	clr.w		d2					;number of matches
SearchThroughEachElementLoop:
	addq.w	#1,d1					;increase the atomic number/counter
	cmpi.w	#113,d1
	beq.s		Return4
	move.l	d6,a0					;point a0 to the begining of typed in string 
CompareTheBytes:
	cmp.b		(a0)+,(a1)+
	beq.s		CompareTheBytes
	tst.b		-(a1)					;see if it was an entire match like H with
	bne.s		AdvancePointer			; Hydrogen
	tst.b		(a0)
	beq.s		SavePossible
	clr.w		d7
	bra.s		SkipSave
SavePossible:
	move.w	d1,d7					;save the possible
SkipSave:
AdvancePointer:
	tst.b		(a1)+					;advance the pointer to the next symbol
	bne.s		AdvancePointer
	tst.b		(a0)					;did I hit a zero? If I did then I have a match
	bne.s		SearchThroughEachElementLoop
	addq.b	#1,d2					;increase the number of matches
	move.w	d1,d3					;most recent find, if matches equal one
								;  then it is the only find.
	bra.s		SearchThroughEachElementLoop
Return4:
	rts