;copywrite 2000 Samuel Stearley

 ifd ti92
GetKey:
	jsr		flib::idle_loop
	rts
ClearScr:
	jsr		flib::zap_screen
	movem.l	d0/d1/a0,-(a7)
	lea		LCD_MEM+30*121,a0
	moveq		#-1,d1
	moveq		#6,d0
Line:
	move.l	d1,(a0)+
	dbra		d0,Line
	move.w	d1,(a0)
	movem.l	(a7)+,d0/d1/a0
	rts
 endc

 ifd ti92plus
GetKey:
	movem.l	d1/d2/a0/a1,-(a7)
	lea		stringPointer(pc),a0
	tst.l		(a0)
	beq.s		NoFakeKeyPress
	move.l	(a0),a1		;get pointer to fake keypress
	moveq		#0,d0			;will use a byte as a word
	move.b	(a1)+,d0		;get it
	move.l	a1,(a0)
	tst.w		d0			;so was there a fake keypress?
	bne.s		ReturnFakeKeyPress
	clr.l		(a0)			;indicate that there are no more fakes
NoFakeKeyPress:
	move.l	200,a0
	clr.l		-(a7)
	clr.w		-(a7)
	move.l	1528(a0),a0
	jsr		(a0)
	addq.l	#6,a7
ReturnFakeKeyPress:
	movem.l	(a7)+,d1/d2/a0/a1
	rts
 endc

 ifnd ti92

ClearScr:
	movem.l	d0/d1/a0,-(a7)
	move.w	#959,d0
	lea		LCD_MEM,a0
ClearLoop:
	clr.l		(a0)+
	dbra		d0,ClearLoop

	 ifd ti92plus
		lea		LCD_MEM+30*121,a0
		moveq		#-1,d1
		moveq		#6,d0
Line:
		move.l	d1,(a0)+
		dbra		d0,Line
		move.w	d1,(a0)+
	 endc

	movem.l	(a7)+,d0/d1/a0
	rts

 endc
;----------------------------------------------------------
;This will handle the right and left arrows and searches
;which are used on all data pages as well as the trait
;grapher.
;----------------------------------------------------------
HandleCommonKeys:
	bsr		GetKey

 ifd ti89
	moveq		#1,d1
	cmpi.b	#K_RIGHT,d0
	beq.s		MoveHorizontaly
	moveq		#-1,d1
	cmpi.b	#K_LEFT,d0
	beq.s		MoveHorizontaly
	move.w	d3,d5					;Save it; in case I want to exit a search
	cmpi.b	#K_F1,d0
	lea		sNumber(pc),a6			;title of the box
	beq		InputIt
	lea		symbols_E2(pc),a4			;list of symbols
	lea		sSymbol(pc),a6			;title of the box
	cmpi.b	#K_F2,d0
	beq		TextSmartSearch
	lea		names_E2(pc),a4			;list of names
	lea		sName(pc),a6			;title of the box
	cmpi.b	#K_F3,d0
	beq		TextSmartSearch
 endc

 ifnd ti89
	moveq		#1,d1
	cmpi.w	#K_RIGHT,d0
	beq.s		MoveHorizontaly
	moveq		#-1,d1
	cmpi.w	#K_LEFT,d0
	beq.s		MoveHorizontaly
	move.w	d3,d5					;Save it; in case I want to exit a search
	cmpi.w	#K_F1,d0
	lea		sNumber(pc),a6			;title of the box
	beq		InputIt
	lea		symbols_E2(pc),a4			;list of symbols
	lea		sSymbol(pc),a6			;title of the box
	cmpi.w	#K_F2,d0
	beq		TextSmartSearch
	lea		names_E2(pc),a4			;list of names
	lea		sName(pc),a6			;title of the box
	cmpi.w	#K_F3,d0
	beq		TextSmartSearch

 endc

	rts

 ifd ti92plus
UpDelay:
	lea		yaptDelayRate(pc),a0
	cmp.w		#100,(a0)
	beq		SkipWraper2
	addq.w	#1,(a0)	
	lea		upDelayMsg(pc),a4
	bra		SetDelay
DownDelay:
	lea		yaptDelayRate(pc),a0
	tst.w		(a0)
	beq		SkipWraper
	subq.w	#1,(a0)
	lea		downDelayMsg(pc),a4
SetDelay:
	move.w	(a0),-(a7)
	move.l	200,a0
	move.l	2340(a0),a0		;set the delay rate
	jsr		(a0)
	move.w	#4,-(a7)
	move.l	a4,-(a7)
	pea		123			;x=0, y=123
	jsr		(a2)
	lea		12(a7),a7
	moveq		#1,d0			;z flag = 0
	rts
 endc

MoveHorizontaly:
	moveq		#112,d0
	add.w		d1,d3
	ble.s		TooLow
	neg		d0
	cmp.b		#113,d3
	bcs		SkipWraper2
TooLow:
	add.w		d0,d3
SkipWraper2:
	clr.w		d0				;the key press was handled and so does not need
	rts						;  to be returned to where it was called from
;-----------------------------------------------------------------------
;display the symbol, number, and side arrows.
;This handles the keys common to all data pages.
;
;Else it will pass the unhandled key press to the code that calls the
;routine.  The second entrance does not draw out the arrows, symbol,
;and atomic number so it is used by the main data page.
;-----------------------------------------------------------------------
Scroller:
	bsr	DSymbolNumber

Idler2:

 ifd ti89
	bsr		HandleCommonKeys		;idle
	beq		SkipWraper2
	cmpi.b	#K_F4,d0
	beq		DisplayHelp
	cmpi.b	#K_F5,d0
	beq		ToggleLabelTypes
	cmpi.b	#K_ESC,d0
	beq.s		Exit
	cmpi.b	#MM_COMP,d0
	beq		DriveMolarMass
	cmpi.b	#EL_DIF,d0
	beq		ElectroNegativityDifferences
	cmp.b		#N_QUIZ,d0
	beq		NameQuiz
	cmpi.b	#S_QUIZ,d0
	beq		SymbolQuiz
	cmpi.b	#K_GRAPH,d0
	beq		TraitGrapher
	cmpi.b	#K_MASS_COPY,d0
	beq		PutMassInClipboard
	cmpi.b	#K_EXPORT,d0
	beq		Export
	rts
 endc

 ifnd ti89
	bsr		HandleCommonKeys		;idle
	beq		SkipWraper2
	cmpi.w	#K_F4,d0
	beq		DisplayHelp
	cmpi.w	#K_F5,d0
	beq		ToggleLabelTypes
	cmpi.w	#K_ESC,d0
	beq.s		Exit
	cmpi.w	#MM_COMP,d0
	beq		DriveMolarMass
	cmpi.w	#EL_DIF,d0
	beq		ElectroNegativityDifferences
	cmp.w		#N_QUIZ,d0
	beq		NameQuiz
	cmpi.w	#S_QUIZ,d0
	beq		SymbolQuiz
	cmpi.w	#K_GRAPH,d0
	beq		TraitGrapher

	 ifnd ti92
		cmpi.w	#K_MASS_COPY,d0
		beq		PutMassInClipboard
		cmpi.w	#K_EXPORT,d0
		beq		Export
		cmp.w		#'+',d0
		beq		UpDelay
		cmp.w		#'-',d0
		beq		DownDelay
	 endc

	rts
 endc

Exit:
	lea		prevNumber(pc),a0
	move.w	d3,(a0)
	addq.l	#4,a7				;get past return address
ContinueExit:					;this entrance is used when exiting formula editor
	lea		4640(a7),a7

 ifd ti89
	lea		variables(pc),a0
	move.w	(a0)+,d0			;get old interupt prioirity
	trap		#1				;set it
	move.l	(a0)+,$40074
	move.l	(a0)+,$40068
 endc

 ifnd ti92
	lea		LCD_MEM+3840,a0
	move.w	#959,d0
Restore:
	move.l	(a7)+,-(a0)
	dbra		d0,Restore
	move.l	200,a2
	move.l	1536(a2),a0			;flush the keyboard
	jsr		(a0)

	 ifd ti92plus
		move.w	tiosDelayRate(pc),-(a7)
		move.l	2340(a2),a0		;set the delay rate
		jsr		(a0)
		addq.l	#2,a7
	 endc

	pea		website(pc)
	move.l	920(a2),a0
	jsr		(a0)
	addq.l	#4,a7
 endc

	movem.l	(a7)+,d0-d7/a0-a6
	rts

ToggleLabelTypes:
	lea		labelTypeAndLabelTypeChangeIndicator(pc),a0
	not.w		(a0)
	bra		SkipWraper2
DisplayHelp:
	lea		about(pc),a4
	bsr		TextDisplayLoop
	bsr		GetKey
	bra		SkipWraper2
;------------------------------------------------
;NOW FOR A ROUTINE TO DISPLAY THE ATOMIC NUMBER,
;SYMBOL AND SIDE ARROWS
;------------------------------------------------
DSymbolNumber:
	move.w	#4,-(a7)
	pea		sideArrows(pc)
	move.l	#(ADD_X+135)*65536+ADD_Y+82,-(a7)
	jsr		(a2)
	move.w	d3,d0
	lea		symbols_E3(pc),a0
Loopertsa:
	tst.b		(a0)+
	bne.s		Loopertsa
	dbra		d0,Loopertsa
	subq.w	#3,2(a7)				;alter y
	add.w		#4,(a7)				;alter x
	move.l	a0,4(a7)
	jsr		(a2)
	move.w	d3,d0
	bsr		BinToDecimal_E2
	add.w		#6,2(a7)				;alter y
	jsr		(a2)
	lea		10(a7),a7

 ifnd ti89
	lea		names_E3(pc),a0
	move.w	d3,d0
GName
	tst.b		(a0)+
	bne		GName
	dbra		d0,GName
	move.w	#4,-(a7)
	move.l	a0,-(a7)
	pea		123			;x=0, y=123
	jsr		(a2)
	lea		10(a7),a7
 endc

	rts
 ifnd ti92
;-Input----------------------------------------------
;d3->Atomic number
;-Output---------------------------------------------
;Mass is converted to a string and placed into the
; clip board.  The program will then terminate
;----------------------------------------------------
PutMassInClipboard:
	move.w	d3,d0					;atomic #, input to advancer
	moveq		#1,d1					;want mass, input to advancer
	bsr		Advancer				;get pointer to it in a6
	moveq		#2,d2					;convert 4 bytes
	lea		50(a3),a0
	bsr		ConvertBcd_E2
	lea		50(a3),a6
	bsr		PlaceInClipboard
	bra		Exit					;then exit the program
;-Input----------------------------------------------
;a6->pointer to the string
;-Output---------------------------------------------
;the string is placed into the clipboard
;----------------------------------------------------
PlaceInClipboard:
	movem.l	d0-d2/a0-a1/a6,-(a7)
	moveq		#-1,d0
	move.l	a6,d1
CounterLoop:
	addq.l	#1,d0
	tst.b		(a6)+
	bne.s		CounterLoop
	clr.w		-(a7)				;copy flag
	move.l	d0,-(a7)			;number of entries
	move.l	d1,-(a7)			;address to copy from
	move.l	200,a0
	move.l	772(a0),a0			;replace clipboard call
	jsr		(a0)
	lea		10(a7),a7
	movem.l	(a7)+,d0-d2/a0-a1/a6
	rts
 endc
;-Input-------------------------------------------------------------------------------
;a2->string display call
;a4->pointer to a structure
;-Output------------------------------------------------------------------------------
;a2->unchanged
;a4->Advanced
;d4->changed
;-------------------------------------------------------------------------------------
TextDisplayLoop:
	bsr		ClearScr
TextDisplayLoop_E3:
	clr.w		d4
	move.b	(a4)+,d4
	move.w	#4,-(a7)
	subq.l	#4,a7					;gap for the addresses
	clr.l		-(a7)					;cordinates, have to clear it rather than
								;  subtract four
LoopNow:
	move.b	(a4)+,3(a7)				;y
	move.b	(a4)+,1(a7)				;x
	move.l	a4,4(a7)				;address
	jsr		(a2)
AdvanceStringPointer:
	tst.b		(a4)+
	bne.s		AdvanceStringPointer
	dbra		d4,LoopNow
	lea		10(a7),a7
	rts
;-Input------------------------------------------------------------------------------
;a2->string display call
;a4->cordinates
;a6->data
;d4->number of things to display-1
;d6->flags
;d7->first flag to test
;-Output-----------------------------------------------------------------------------
;a0->changed
;a4->advanced
;a6->advanced
;d2->changed
;d4->negative one loop variable
;d7->advanced
;------------------------------------------------------------------------------------
DataDisplayLoop:
	move.w	#4,-(a7)
	subq.l	#4,a7					;gap for the address
	clr.l		-(a7)					;gap for the cordinates
LoopAndDisplay:
	move.b	(a4)+,3(a7)				;get the new cordinates
	move.b	(a4)+,1(a7)
	btst.l	d7,d6					;is it known?
	bne.s		DoNotDisplayAnything
	subq.b	#1,d7
	btst.l	d7,d6					;how is the data stored?
	beq.s		ItIsABcd
	bsr		BinToDecimal			;convert from binary to decimal
	bra.s		DisplayIt
ItIsABcd
	moveq		#1,d2					;convert 3 bytes
	bsr		ConvertBcd				;convert it
DisplayIt:
	jsr		(a2)
	addq.b	#1,d7					;for compatability with the next instruction
DoNotDisplayAnything:
	addq.b	#2,d7					;next exist bit
	dbra		d4,LoopAndDisplay
	lea		10(a7),a7
	rts
;-Input-------------------------------------------------------------------------
;a0->pointer to a structure, displays element type data and other text properties
;a2->string display call
;d0->atomic number, which is the number of zeros to bypass OR d0->copy of the
;	atomic number depending on which entrance is used
;-Output------------------------------------------------------------------------
;a4->changed
;d0->changed
;--------------------------------------------------------------------------------
DisplayIndexedStrings:
	clr.w		d0					;want to use byte as a word
	move.b	(a6)+,d0
DisplayIndexedStrings_E2:
	move.w	#4,-(a7)
	subq.l	#4,a7					;gap for the address
	clr.l		-(a7)					;gap for cordinates
	move.b	(a0)+,3(a7)				;get the y
	move.b	(a0)+,1(a7)				;get the x
Loopert:
	tst.b		(a0)+
	bne.s		Loopert
	dbra		d0,Loopert
	move.l	a0,4(a7)
	jsr		(a2)
	lea		10(a7),a7
	rts
;-Input-------------------------------------------------------------------------
;a0->pointer to a structure, displays element type data and other text properties
;	but they will be right justified
;a2->string display call
;d0->atomic number, which is the number of zeros to bypass OR d0->copy of the
;	atomic number depending on which entrance is used
;-Output------------------------------------------------------------------------
;a4->changed
;d0->changed
;--------------------------------------------------------------------------------
DisplayIndexedStringsRightJustify:
	clr.w		d0			;want to use byte as a word
	move.b	(a6)+,d0
DisplayIndexedStringsRightJustify_E2:
	move.w	#4,-(a7)
	subq.l	#4,a7			;gap for the address
	clr.l		-(a7)			;gap for cordinates
	move.b	(a0)+,3(a7)		;get the y
	move.b	(a0)+,1(a7)		;get the x
Loopert2:
	tst.b		(a0)+
	bne.s		Loopert2
	dbra		d0,Loopert2
	move.l	a0,4(a7)

 ifnd ti92
	clr.w		-(a7)
	move.l	a0,-(a7)
	move.l	200,a0
	move.l	1628(a0),a0
	jsr		(a0)			;get the width
	addq.l	#6,a7
	sub.w		d0,(a7)		;modify the x
 endc

 ifd ti92
	movem.l	d3/d4,-(a7)
	jsr		graphlib::getlength
	move.w	d3,d0
	movem.l	(a7)+,d3/d4
	sub.w		d0,(a7)
 endc

	jsr		(a2)
	lea		10(a7),a7
	rts
;-Input------------------------------------------------------------------------------
;a2->string display call
;a4->cordinates
;a6->data
;d4->number of things to display-1
;d6->flags
;d7->first flag to test
;-Output-----------------------------------------------------------------------------
;a0->changed
;a4->advanced
;a6->advanced
;d2->changed
;d4->negative one loop variable
;d7->advanced
;------------------------------------------------------------------------------------
Disp2ByteBcd:
	moveq		#0,d5					;convert two bytes
Disp2ByteBcd_E2:
	move.w	#4,-(a7)				;color
	subq.l	#4,a7
	clr.l		-(a7)
Loopxer:
	move.b	(a4)+,3(a7)				;y
	move.b	(a4)+,1(a7)				;x
	btst.l	d7,d6					;is it known?
	bne.s		NotExist
	move.l	d5,d2
	bsr		ConvertBcd
	jsr		(a2)
NotExist:
	subq.w	#1,d7
	dbra		d4,Loopxer
	lea		10(a7),a7
	rts

 ifnd ti92
;---Inputs----------------------------------------------------------------------------
;a0->pointer to the end zero of the name
;a4->pointer to the byte after the list tag
;1000(a3)->Where the list was made
;---Outputs---------------------------------------------------------------------------
;The vat entry is made, a handle is allocated, and the handle is placed into the vat
;entry.
;
;Returns the carry set if successful
;-------------------------------------------------------------------------------------
MakeEntry:
	move.l	a0,-(a7)		;put pointer onto the stack
	move.l	200,a6		;rom call table
	move.l	368(a6),a0		;symbol creation call
	jsr		(a0)			;create a new vat entry
	addq.l	#4,a7			;pop it off
	move.l	d0,d7			;save hsym structure
	beq.s		ErrorWithCreation

;---ALLOCATE MEMORY AND COPY THE LIST STORED IN RAM ALLOCATED OFF OF THE STACK
;---TO THE RAM ALLOCATED OFF OF THE HEAP.

	lea		1000(a3),a4		;pointer to the list
	sub.l		a4,a2			;decrease it
	move.l	a2,d4
	addq.l	#2,d4			;also have to allocate memory for the offset
	move.l	d4,-(a7)
	move.l	588(a6),a0
	jsr		(a0)			;allocate the memory and get handle
	move.w	d0,-(a7)		;input on the stack
	beq		MemoryErrors
	move.l	600(a6),a0		;get dereference call
	jsr		(a0)			;get pointer to allocated memory
	subq.w	#2,d4			;offset to tag
	move.w	d4,(a0)+
	subq.w	#1,d4			;for dbra
CopyListLoop:
	move.b	(a4)+,(a0)+
	dbra		d4,CopyListLoop

;--GET A POINTER TO THE VAT ENTRY AND MOVE IN THE HANDLE----

	move.w	(a7)+,d6		;get handle back
	move.l	d7,-(a7)		;put hsym onto stack
	move.l	484(a6),a0		;get hsym dereference call
	jsr		(a0)			;do the call
	move.w	d6,$C(a0)		;put handle into the vat entry
	addq.l	#8,a7			;reset the stack
	move		#1,ccr
	rts					;all done

;----Handle a memroy error by deleting the created symbol and
;----Displaying a message.

MemoryErrors:
	move.l	d7,-(a7)
	move.l	380(a6),a0
	jsr		(a0)			;delete the hsym
	addq.l	#4,a7
ErrorWithCreation:
	move		#0,ccr
	rts
 endc
;---Input--------------------------------------------------
;a6->	pointer to the word OR d0->the word to convert
;	depending on which entrance is used
;---Output-------------------------------------------------
;a6->	might be advanced depending on which entrance is used
;d5-> width of the string plus 4; this is used for the bohr
;	model
;Stack is loaded with the address of the string for the
;	string display rom call
;----------------------------------------------------------
BinToDecimal:
	move.b	(a6)+,d0
	lsl.w		#8,d0
	move.b	(a6)+,d0
BinToDecimal_E2:
	moveq		#4,d5
	lea		60(a3),a0
	clr.b		(a0)
BinaryLoop:
	divu		#$A,d0
	swap		d0
	add.b		#'0',d0
	move.b	d0,-(a0)
	addq.w	#4,d5
	clr.w		d0
	swap		d0
	bne.s		BinaryLoop
DoneBinary:
	move.l	a0,8(a7)
	rts
;---Input--------------------------------------------------
;a6->	pointer to the data
;d2->	number of bytes to convert minus 2
;---Output-------------------------------------------------
;a0->	advanced to the end of the generated string
;a6->	advanced past the data
;Stack is loaded with the address of the string for the
;	string display rom call.
;----------------------------------------------------------
ConvertBcd:
	lea		50(a3),a0
	move.l	a0,8(a7)
ConvertBcd_E2:
	move.b	(a6),d0
	bpl.s		SkipNegative
	bclr.b	#7,d0
	move.b	#173,(a0)+
SkipNegative:
	lsr.b		#4,d0
	subq.b	#1,d0
	bsr		ExtractLowerNyble
BcdLoop:
	bsr		ExtractUpperNyble
	bsr		ExtractLowerNyble
	dbra.s	d2,BcdLoop
LoopB:
	clr.b		(a0)
	cmp.b		#'0',-(A0)
	beq.s		LoopB
	bcc.s		Return
	clr.b		(a0)
Return:
	rts
ExtractLowerNyble:
	move.b	(a6)+,d1
	and.b		#%00001111,d1
	bra.s		DoTheRest2
ExtractUpperNyble:
	move.b	(a6),d1
	lsr.b		#4,d1
DoTheRest2:
	cmp.b		#$0A,d1
	beq.s		PlaceSigFigZero
	cmp.b		#$0B,d1
	beq.s		AutoFinishIt
	bcc.s		IncreaseCounter
	add.b		#'0',d1
	move.b	d1,(a0)+
	subq.b	#1,d0
	bne.s		DontPlaceDecimalP2
	move.b	#'.',(a0)+
DontPlaceDecimalP2:
	rts
PlaceSigFigZero:
	move.b	#'0',(a0)+
	move.b	#'.',(a0)+			;the decimal point will protect the zero
							;  from getting taken off by the end code.
	rts
AutoFinishIt:
	addq.l	#4,a7
	bra.s		LoopB
IncreaseCounter:
	sub.b		#11,d1
	add.b		d1,d2
	rts
;---DATA DISPLAYED WITH CHART-----------------------Data Item Number-----------------
;	element type->1 byte
;	atomic mass->4 bytes					1
;	hardness-> 2 bytes					2
;	electronegativity->2 bytes				3
;	negative oxstates,positive oxstates->2 bytes
;	melting point->2 or 3 bytes				4
;	boiling point->2 or 3 bytes				5
;	heat of vaporization->2 or 3 bytes			6
;	heat of fusion->2 or 3 bytes				7
;	specific heat->2 or 3 bytes				8
;	electron affinity->2 or 3 bytes			9
;	density->2 or 3 bytes					10
;	heat of atomization->2 or 3 bytes			11
;	polorizability						12
;	atomic volume->2 or 3 bytes				13
;	thermal conductivity->2 or 3 bytes			14
;	electric conductivity->2 or 3 bytes			15
;	date discovored->2 or 3 bytes				16
;---ELECTRON EXTENDED DATA PAGE-----------------------------------------------------
;	how to patch the suborbital diagram->2 bytes	17	-needed when going to the
;	first ionic energy->2 or 3 bytes			18	 electron data page
;	second ionic energy->2 or 3 bytes			19
;	third ionic energy->2 or 3 bytes			20
;	atomic radius->2 bytes					21
;	2- Ionic radius->2 bytes				22
;	1- Ionic radius->2 bytes				23
;	1+ Ionic radius->2 bytes				24
;	2+ Ionic radius->2 bytes				25
;	3+ Ionic radius->2 bytes				26
;---3rd EXTENDED DATA PAGE----------------------------------------------------------
;	crystal structure and acid base property->1 byte: a nyble is used for each  27
;	element color ->1 byte
;	abundance in the earth's crust->2 bytes		28
;	abundance in the solar system->3 bytes		29
;-----------------------------------------------------------------------------------

;--INPUTS--------------------------------------------------------
;d0->Atomic item
;d1->Data item number
;--Outputs-------------------------------------------------------
;a6->Points to data item
;d6->Loaded with flags
;d2->existence bit of that item
;----------------------------------------------------------------
Advancer:
	movem.l	a0/a1/d0/d1/d4/d5/d7,-(a7)
	lea		base(pc),a0
	lea		elementFlags(pc),a1
	subq.w	#1,d0
	move.w	d0,2(a3)				;save it for later
	add.w		d0,d0
	move.w	0(a0,d0.w),d2
	move.w	d0,d7
	add.w		d0,d0
	move.l	0(a1,d0.w),d6
	lea		1(a0,d2.w),a6
	moveq		#0,d2
	subq.b	#1,d1					;see if I want the mass
	beq.s		A6PointsToIt
	addq.l	#4,a6

;--Now get past two byters---

	moveq		#2,d2
	moveq		#1,d5
	bsr		AdvancePast2Byters

;--now get past the oxsets---

	btst.l	#3,d6
	bne.s		SkipAddNow
	addq.l	#2,a6
SkipAddNow:

;--now get past numeric items on the main page---

	moveq		#3,d0
	moveq		#5,d2
	moveq		#12,d5
	bsr		AdvancePastData

;--Get flags of electron data page

	lea		electronDataFlags(pc),a0
	move.w	0(a0,d7.w),d6

;--Do I want a pointer to the electron data page data?---

	subq.b	#1,d1
	beq.s		A6PointsToIt

;--now get past abnormal electron diagram data---

	btst.w	#15,d6
	beq.s		SkipAddTwo
	addq.l	#2,a6
SkipAddTwo:

;--now get past the ionic energies---

	moveq		#3,d0					;width of it
	moveq		#2,d5					;3 things to to get past
	moveq		#1,d2					;first bit to test
	bsr		AdvancePastData			;get past the data

;--now get past the various radii---

	moveq		#5,d5					;6 to get past
	moveq		#12,d2				;first bit to test
	bsr		AdvancePast2Byters		;get past the data

;--Get third data page flags

	lea		_3rdFlags(pc),a0
	move.w	2(a3),d0
	move.b	0(a0,d0.w),d6			;get flags of this page

;--do I want a pointer to the third data page?---
	
	subq.b	#1,d1
	beq.s		A6PointsToIt

;--Get past the text data intergers

	addq.l	#2,a6

;--Get past earth's crust abundance------

	moveq		#7,d2
	moveq		#0,d5	
	bsr		AdvancePast2Byters

;--And by default it points to the solar system abundance------

	bra.s		A6PointsToIt

A6PointsToIt2:
	add.l		#4,a7
A6PointsToIt:
	movem.l	(a7)+,a0/a1/d0/d1/d4/d5/d7
	rts
;----------------------------------------------------------------
;The following are advancement subroutines to get past different
;types of data items.
;----------------------------------------------------------------
AdvancePast2Byters:
	subq.b	#1,d1
	beq.s		A6PointsToIt2
	btst.l	d2,d6			;is the data known?
	bne.s		SkipAdder
	moveq		#2,d0			;2 bytes wide
	bsr		AdvanceBcd
SkipAdder:
	subq.l	#1,d2
	dbra.s	d5,AdvancePast2Byters
	rts
AdvancePastData:
	subq.b	#1,d1				;decrease data item counter
	beq.s		A6PointsToIt2		;if it is zero then a6 points to it
	btst.l	d2,d6				;does it exist?
	bne.s		NotExister
	subq.w	#1,d2
	btst.l	d2,d6				;is it a bcd or a word?
	bne.s		ItIsAWord
	bsr		AdvanceBcd			;advance past the bcd, it might be extra big or small
	bra.s		Contin
ItIsAWord
	addq.l	#2,a6				;point past a word
Contin:
	addq.b	#1,d2				;bring it back up
NotExister
	addq.b	#2,d2				;point to next exist bit
	dbra.s	d5,AdvancePastData
	rts
AdvanceBcd:
	add.l		d0,a6
	moveq		#0,d4
	move.b	-1(a6),d4
	and.b		#%00001111,d4
	cmp.b		#$0B,d4
	bhi.s		IncrementMore
	move.b	-2(a6),d4
	and.b		#%00001111,d4
	cmp.b		#$0B,d4
	bne.s		Return5
	subq.l	#1,a6
Return5:
	rts
IncrementMore:
	sub.b		#11,d4
	add.l		d4,a6
	rts
;-----------------------------------------------
;CODE TO SELECT A DATA ITEM TO GRAPH OR
;TO EXPORT.  IT RETURNS IN D1 THE ITEM NUMBER
;OF THE DATA TO GRAPH.
;-----------------------------------------------
MenuSelect:
	lea		traitSelection(pc),a4		;text to display
	bsr		TextDisplayLoop			;clear the screen and display it
	moveq		#0,d4					;currently selected item
KeyLoop2:
	bsr		XorMark				;place d4 at the corect spot
KeyLoop:
	bsr		GetKey

 ifd ti89
	moveq		#-1,d5
	cmp.b		#K_UP,d0
	beq.s		MoveIt
	moveq		#1,d5
	cmp.b		#K_DOWN,d0
	beq.s		MoveIt
	moveq		#-14,d5
	cmp.b		#K_LEFT,d0
	beq.s		MoveIt
	moveq		#14,d5
	cmp.b		#K_RIGHT,d0
	beq.s		MoveIt
	cmp.b		#K_ENTER,d0
	beq.s		ItemSelected
	cmp.b		#K_DATUM_SCROLLER,d0
	beq		StoreItToHistory
	cmp.b		#K_ESC,d0
	bne.s		KeyLoop
	addq.l	#4,a7
	bra		SkipWraper2
 endc

 ifnd ti89
	moveq		#-1,d5
	cmp.w		#K_UP,d0
	beq.s		MoveIt
	moveq		#1,d5
	cmp.w		#K_DOWN,d0
	beq.s		MoveIt
	moveq		#-14,d5
	cmp.w		#K_LEFT,d0
	beq.s		MoveIt
	moveq		#14,d5
	cmp.w		#K_RIGHT,d0
	beq.s		MoveIt
	cmp.w		#K_ENTER,d0
	beq.s		ItemSelected

	 ifnd ti92
		cmp.w	#K_DATUM_SCROLLER,d0
		beq	StoreItToHistory
	 endc

	cmp.w		#K_ESC,d0
	bne.s		KeyLoop
	addq.l	#4,a7
	bra		SkipWraper2
 endc

XorMark:
	move.w	#2,-(a7)
	pea		mark(pc)
	move.w	d4,d0				;going to alter it
	mulu		#7,d0
	addq.w	#3,d0
	move.w	d0,-(a7)			;y
	move.w	#5,-(a7)			;x
	cmp.w		#14,d4
	bcs.s		Column1
	sub.w		#98,2(a7)
	move.w	#80,(a7)
Column1:
	jsr		(a2)
	lea		10(a7),a7
	rts
MoveIt:
	bsr		XorMark
	add.w		d5,d4				;alter position
	bmi.s		UndoMath
	cmp.w		#27,d4
	bcs.s		WithinLimits
UndoMath:
	sub.w		d5,d4
WithinLimits:
	bra		KeyLoop2
;------------------------------------------------------------------
;NOW TO FIGURE OUT THE PLACEMENT
;OF THE DATA ITEM SELECTED, WHICH
;IS NOT THE VALUE IN D4.
;------------------------------------------------------------------
ItemSelected:
	lea		itemNumberTable(pc),a0
	moveq		#0,d1
	move.b	0(a0,d4),d1
	rts

 ifnd ti92

StoreItToHistory:
	lea		itemNumberTable(pc),a0
	moveq		#0,d6
	move.b	0(a0,d4),d6
	moveq		#0,d4
	bsr		MakeString_E2
	tst.l		d0
	bne		Exists
	bsr		SetFontMedium
	move.w	#0,-(a7)
	pea		unknown(pc)
	move.l	#60*65536+46,-(a7)
	jsr		(a2)
	lea		10(a7),a7
	bsr		SetFontSmall
	bsr		GetKey
	bra		MenuSelect
Exists:
	pea		MenuSelect
	bsr		ExportIntoHistory_E2	;will return to the menu select
 endc

 ifd ti89
;---INPUT----------------------------------------
;carry flag set for letters
;no carry for numbers
;---OUPUT----------------------------------------
;d0.b->interger code, often the ascii equivilent
;------------------------------------------------
GetKey:
	movem.l	d1-d5/a0-a4,-(a7)
	lea		int2Indic(pc),a4
	lea		$600018,a2				;address to store the mask
	lea		numbers(pc),a0
	bcc.s		PollForKeys
	lea		lowerCaseLetters(pc),a0
PollForKeys:

;---First see if there are keys that should be sent instead
;---This is for re-editing chemical formulas

	lea		stringPointer(pc),a1
	tst.l		(a1)
	beq.s		NoFakeKeyPress2
	move.l	(a1),a0		;get pointer to fake keypress
	move.b	(a0)+,d0		;get it
	move.l	a0,(a1)
	tst.b		d0			;so was there a fake keypress?
	bne		ReturnFakeKeyPress2
	clr.l		(a1)			;indicate that there are no more fakes
	bra		ReturnFakeKeyPress2
NoFakeKeyPress2:

;----Now for the actual hardware driver------------

KeyTestingTime:
	clr.b		-1(a4)				;clear int 5 indic

;----Now go row by row and column by column----

KeyTestingLoop:
	moveq		#0,d4					;will hold keypress
	moveq.l	#6,d2					;row counter there are 7 rows
	move.l	a0,a1					;a1 is the copy that I manipulate
	move.w	#$FFFF-1,d3				;the mask
NextRow:
	move.w	d3,(a2)
	moveq		#$58,d1
_zzz:
	dbra		d1,_zzz
	moveq.l	#7,d1					;column counter
	move.b	3(a2),d0				;get the bits to test
LoopTester:
	lsl.b		#1,d0					;shift it into the carry
	bcs.s		NotPressed				;there is a carry if it was not pressed
	tst.b		d4					;was a key already pressed?
	bne		GoBackToIdling			;if multiple keys then we ignore them
	move.b	(a1),d4				;get keypress
	move.w	d3,d5					;save the row mask of this keypress
NotPressed
	addq.l	#1,a1
	dbra		d1,LoopTester
	rol.w		#1,d3					;let in the next row
	dbra		d2,NextRow				;repeat this again for the next row

;----All done analyze keypress-------

	tst.b		d4
	bne		AKeyWasPressed
NotRepeatedKeyPressed:
	clr.b		1(a4)				;same key was not held down too long
	clr.b		2(a4)
	tst.b		-1(a4)
	beq		KeyTestingLoop

;----Now to save some power------

GoBackToIdling:
	moveq		#8,d0			;the counter
	clr.b		(a4)
	move.w	#$0280,(a2)		;what tios idle puts to this port, unmask all
						;  rows.  Tios does not wait for hw to settle
						;  before writting to the low power port.
OnlyInt5:
	move.w	blinker(pc),d3
	beq		NoBlinking
	subq.w	#1,d0
	bne		NoBlinking

;----Blink the box-----------

	bsr		InvertBox
	moveq		#7,d0

;----Now for low power--------

NoBlinking:
	move.b	#%10010,$600005	;turn off calc till on button, int 5, int 2
	nop					;tios idle has a nop here
	tst.b		(a4)			;see if it woke b/c of interupt 2
	beq.s		OnlyInt5
	bra		KeyTestingLoop	;something was pressed so get it

;----Now to react to that key------

AKeyWasPressed:
	moveq		#0,d0
	move.b	d4,d0
	cmpi.b	#8,d0			;is it an arrow or backspace? if so I can repeat it
	bcs.s		IsRepeatable
	tst.b		1(a4)
	bne		KeyTestingLoop	;if it is zero then i got through all the
						;  above looping once without finding a key
						;  which means a key was not being held down
	bra.s		SkipDelay

;----Now for some delays if it was an arrow key-----

IsRepeatable:
	move.w	d5,(a2)		;put out the mask, we will need to see if
	moveq		#27,d1		;  it is still held down.
l:	dbra		d1,l			;let hardware settle
	tst.b		1(a4)
	beq		SkipDelay
	tst.b		2(a4)			;is some extra needed?
	beq.s		NoExtra

;---the long delay before autorepeation starts---

	move.b	d0,d2
	subq.w	#1,d2			;point to the bit
	moveq		#4,d1
	clr.b		(a4)
Delay3
	move.b	#%10010,$600005
	nop
	tst.b		(a4)			;int 2?
	bne		KeyTestingTime
	btst.b	d2,3(a2)		;still down?
	bne		KeyTestingTime
	dbra		d1,Delay3
	clr.b		2(a4)

;---the short delay between autorepeations once it has started----

NoExtra:
	move.b	d0,d2
	subq.w	#1,d2			;point to the bit
	clr.b		(a4)			;int 2 indic
	move.b	#%10010,$600005
	nop
	tst.b		(a4)			;int 2?
	bne		KeyTestingTime	
	btst.b	d2,3(a2)		;see if it is still down
	bne		KeyTestingTime
	bra		SkipFlagSet

;----Return the key code---------

SkipDelay:
ReturnFakeKeyPress2:
	st.b		2(a4)			;if an arrow is held down then some extra
SkipFlagSet:				;  delay is needed before auto repeating
	move.w	#$0280,(a2)
	st.b		1(a4)			;prevent repeats
	lea		counter(pc),a4
	move.w	(a4),-2(a4)
	move.w	#1200,(a4)		;restart apd
	lea		blinker(pc),a4
	clr.w		(a4)
	movem.l	(a7)+,d1-d5/a0-a4
	rts
;--------------------------------------
;The apd count down timer that runs
;on interupt 5 and the autointerupt
;2 counter that only sets a flag
;--------------------------------------
AutoInterupt5:
	move.l	a0,-(a7)
	lea		counter(pc),a0
	subq.w	#1,(a0)
	bne.s		KeepGoing
	trap		#4
	move.w	#1200,(a0)
KeepGoing:
	st.b		2(a0)
	move.l	(a7)+,a0
	rte
AutoInterupt2:
	move.w	#$2700,sr
	move.l	a0,-(a7)
	lea		int2Indic(pc),a0
	st.b		(a0)				;set int 2 indicator
	move.w	#$FF,$60001A
	move.l	(a7)+,a0
	rte
 endc

 ifnd ti92
;---------------------------------------------------
;THE DATA SCROLLER
;---------------------------------------------------

;----INPUTS----------------------------------------
;A4-points to the structure that has the labels
;a5-points to the shortcut table
;d3-Atomic Number
;d4-has the value to add to the selected element,
;	this is for multiple data pages.
;---------------------------------------------------
DataScroller:
	move.l	a5,-(a7)
	moveq		#0,d5		;use byte as a word
	move.b	(a4)+,d5	;get counter
	moveq		#0,d6		;currently selected datum

;----Get pointer to the correct string to hightlight----

SelectNextDatum:
	move.l	d6,d0
	move.l	a4,a5
	bra		IntoTheLoop
FindStringToHighlight:
	addq.l	#2,a5
AdvanceLoope:
	tst.b		(a5)+
	bne		AdvanceLoope	;get past the zero terminated string
IntoTheLoop:
	dbra		d0,FindStringToHighlight
FoundStringToHighlight:

;-----a5 now points to the coordinates and string to highlight----

	moveq		#0,d0
	move.b	(a5)+,d0
	clr.w		-(a7)		;inverse color
	pea		1(a5)		;pointer
	move.w	d0,-(a7)	;y
	move.b	(a5)+,d0
	move.w	d0,-(a7)	;x
	jsr		(a2)		;Display the highlighted label
	lea		10(a7),a7

;------Now Idle and respond to the keys--------------

ContinueToIdle
NoMatchFound:

 ifd ti89
	move #1,ccr
 endc

	bsr		GetKey

 ifd ti89
	cmp.b		#K_ESC,d0
	beq		DoneDatumScroller
	cmp.b		#K_UP,d0
	beq		ScrollPrevious
	cmp.b		#K_RIGHT,d0
	beq		ExportIntoClipBoard
	cmp.b		#K_LEFT,d0
	beq		ExportIntoHistory
	cmp.b		#K_DOWN,d0
	beq		ScrollNext

;----Now find in the shortcut table----

	move.l	(a7),a0		;get shortcut table
	moveq		#0,d1
FindShortcut:
	tst.b		0(a0,d1)
	beq		NoMatchFound
	cmp.b		0(a0,d1),d0
	beq		MatchFound
	addq.l	#1,d1
	bra		FindShortcut
MatchFound:
	tst.b		(a0)+
	bne		MatchFound		;go to terminator
	moveq		#0,d6
	move.b	0(a0,d1),d6		;get it
	bra		ExportIntoHistory
 endc

 ifd ti92plus
	cmp.w		#K_ESC,d0
	beq		DoneDatumScroller
	cmp.w		#K_UP,d0
	beq		ScrollPrevious
	cmp.w		#K_RIGHT,d0
	beq		ExportIntoClipBoard
	cmp.w		#K_LEFT,d0
	beq		ExportIntoHistory
	cmp.w		#K_DOWN,d0
	beq		ScrollNext

;---Find it in the shortcut table----

	move.l	(a7),a0		;get shortcut table
	moveq		#0,d1
FindShortcut:
	tst.w		0(a0,d1)
	beq		NoMatchFound
	cmp.w		0(a0,d1),d0
	beq		MatchFound
	addq.l	#2,d1
	bra		FindShortcut
MatchFound:
	tst.w		(a0)+
	bne		MatchFound		;go to terminator
	moveq		#0,d6
	move.w	0(a0,d1),d6		;get it
	bra		ExportIntoHistory
 endc

;------Code to scroll to the next-----

ScrollNext:
	cmp.w		d6,d5
	beq		ContinueToIdle
	bsr		ReprintLabel
	addq.l	#1,d6
	bra		SelectNextDatum

;------Code to scroll to the previous-------

ScrollPrevious:
	tst.w		d6
	beq		ContinueToIdle
	bsr		ReprintLabel		;take away the focus
	subq.w	#1,d6
	bra		SelectNextDatum

;------Code to call when done--------------

DoneDatumScroller:
	bsr		ReprintLabel
DoNothing:
	addq.l	#4,a7
	rts
;----Inputs-----------------------------------------
;a5 pointer to the string, coordinates come before
;---------------------------------------------------
ReprintLabel:
	move.w	#4,-(a7)
	move.l	a5,-(a7)
	moveq		#0,d0
	move.b	-(a5),d0
	swap		d0
	move.b	-(a5),d0
	move.l	d0,-(a7)
	jsr		(a2)
	lea		10(a7),a7
	rts
;----------------------------------------
;NOW THE EXPORTING CODE
;----------------------------------------
ExportIntoClipBoard:
	bsr		MakeString
	tst.l		d0
	beq		DoNothing
	bsr		PlaceInClipboard
	addq.l	#4,a7
	bra		Exit
ExportIntoHistory:
	bsr		MakeString
	tst.l		d0
	beq		DoNothing
ExportIntoHistory_E2:
	lea		labelTypeChangeIndicator(pc),a0
	move.b	#1,(a0)			;going to use the backup buffer
	move.l	a6,a0
ContLpe:
	tst.b		(a0)+
	bne		ContLpe

;----Now append the unit data-----------

	moveq		#0,d0
	subq.l	#1,a0		;point to the zero
	lea		unitsTable(pc),a1
	move.b	-1(a1,d6),d0
	lea		unitsToAppend(pc),a1
AdvncePtr:
	tst.b		(a1)+
	bne		AdvncePtr
	dbra		d0,AdvncePtr	;a1 will point to the string
ContCopy:
	move.b	(a1)+,(a0)+
	bne		ContCopy

;----Now to generate the sentence for the entry at 1001(a3)

	lea		1001(a3),a0

;----Now to find the name of the data item-------

	lea		itemNumberTable(pc),a1		;find a match in this table: the index of
								;  the match will let us find the correct
								;  string in the traight selection table
	moveq		#0,d0
	bra		IntoLp
FindIndex:
	addq.l	#1,d0
IntoLp:
	cmp.b		0(a1,d0),d6
	bne		FindIndex
	lea		traitSelection+1(pc),a1
	bra		IntoTheLoop2
TheFindLoop
	addq.l	#2,a1
AdvanceLoopg:
	tst.b		(a1)+
	bne		AdvanceLoopg
IntoTheLoop2
	dbra		d0,TheFindLoop
	addq.l	#2,a1					;now points to the name string

;----Now copy the name loop into the string------

	moveq		#10,d0
CopyTillZero:
	move.b	(a1)+,(a0)+
	dbeq		d0,CopyTillZero
	bne		SkipSub
	subq.l	#1,a0
SkipSub:

;----put in the string " of "

	move.b	#' ',(a0)+
	move.b	#'o',(a0)+
	move.b	#'f',(a0)+
	move.b	#' ',(a0)+

;----Put in the name string, d3 has the atomic number---

	move.w	d3,d0
	lea		names_E3(pc),a1
FindTheName:
	tst.b		(a1)+
	bne		FindTheName
	dbra		d0,FindTheName

;----a1 now points to the name------

CopyIts:
	move.b	(a1)+,(a0)+
	bne		CopyIts

;----Place in string ":"

	subq.l	#1,a0
	move.b	#':',(a0)+
	clr.b		(a0)

;-----Calculate string size------

	lea		1001(a3),a1
	sub.l		a1,a0
	move.w	a0,8(a3)		;size of the string
	clr.w		6(a3)			;incase it prints an error
	moveq		#0,d6
	bsr		CopyToHS
	bsr		SetFontSmall
	addq.l	#4,a7
	rts

;-----This will generate the string of what to export, if unknown
;-----then the return address is poped off and it will go back to
;-----idling.

;---Inputs-------------------------
;d3- atomic number
;d4- stuff to add
;d6- selected item
;a5- pointer to string to unfocus
;---Outputs------------------------
;a6- pointer to the created string
;
;----------------------------------
MakeString:
	bsr		ReprintLabel
MakeString_E2:
	move.w	d6,d7
	move.w	d4,d1
	add.w		d6,d1			;item number
	move.w	d3,d0			;atomic number
	bsr		Advancer
	btst.l	d2,d6
	bne		ErrorNotNkown
	lea		dataFormatTypes(pc),a0
	subq.l	#8,a7
	lsl.w		#1,d1			;make it an index
	move.b	-2(a0,d1),d0	;get size
	tst.b		-1(a0,d1)		;get flag
	bpl.s		NotAWord5
	subq.b	#1,d2
	btst.l	d2,d6
	beq.s		NotAWord5
	move.l	d5,d2
	bsr		BinToDecimal	;convert it- will set string address on the stack
	move.l	d2,d5
	bra.s		DoneValue5
NotAWord5:
	moveq		#0,d2			;will use byte as a word
	move.b	d0,d2			;use the byte
	lsr.w		#1,d2			;divide it in half
	subq.w	#1,d2			;it is one too big
	bsr		ConvertBcd		;convert it- will set string address on the stack
DoneValue5:
	move.w	d7,d6
	add.w		d4,d6
	addq.l	#4,a7
	move.l	(a7)+,a6		;get pointer to the string in a6
	moveq		#1,d0
	rts
ErrorNotNkown:
	move.w	d7,d6			;get back selected numeric item
	moveq		#0,d0
	rts

 endc  ;close the ifnd ti92

 ifd ti89
;---INPUTS---------------------------
;(A3) Points to the index
;---OUTPUTS--------------------------
;The Box is inverted
;------------------------------------
InvertBox:
	movem.l	d0-d2/a0,-(a7)
	moveq		#60,d0
	move.l	#LCD_MEM+7*30,a0
	move.w	(a3),d2
LoopD:
	sub.w		#18,d2		;for every multiple of 18 the index is, it has
						;  to move 2 or 3 lines down
	add.l		d0,a0
	bcc.s		LoopD
	add.w		#18,d2
	move.w	d2,2(a3)
	add.w		d2,d2
	move.w	d2,d1
	lsr.w		#3,d2
	and.w		#7,d1
	add.l		d2,a0			;place in video memory
	move.w	#%11100000,d0
	ror.w		d1,d0			;shift the "sprite"
	eor.b		d0,(a0)
	eor.b		d0,30(a0)
	eor.b		d0,60(a0)
	addq.l	#1,a0
	lsr.w		#8,d0
	eor.b		d0,(a0)
	eor.b		d0,30(a0)
	eor.b		d0,60(a0)
	moveq		#8,d0			;re initiate the counter
	movem.l	(a7)+,d0-d2/a0
	rts
 endc